<?php

require ("../lib-abdesk.php");
CheckCookie();
require ("../settings/settings-backup.php");

session_start();

$errorvarname="abdesk_backup_recent_error";

$prevformname="backup_recent_form";

$poststoget=array("link", "idea", "file", "last_complete_backup_date", "backup_folder_label");

$url_tables=array("urldatesofcollection", "urllongdesc", "urlothernotes", "urlsourcenotes");
$idea_tables=array("idealongdesc", "ideaquote", "ideasourcenotes");
$file_tables=array("imageinfo");

foreach ($poststoget as $postvar)
{
	${$postvar}=$_POST[$postvar];
}

$_SESSION[last_complete_backup_date]=$last_complete_backup_date;
$_SESSION[backup_folder_label]=$backup_folder_label;

if (!$last_complete_backup_date)
{	GoBackToFormWithError("blank date");
	exit;
}
$date_to_search_for=GetTimestamp($last_complete_backup_date);

$last_complete_backup_date_in_unix_time_format=strtotime($last_complete_backup_date);

$last_complete_backup_date_for_file_labels=date("Y_m_d-H,i,s", $last_complete_backup_date_in_unix_time_format);

$nowtime=time();
$nowdate = date("Y_m_d-H,i,s", $nowtime);

//$backupfoldername="$backup_folder_label" . "---$nowdate";

$backupfoldername="$nowdate" . "---Recent_DB_recs---$backup_folder_label";

if ($dailybackupmode)
{	$todaysdate=date("Y-m-d", $nowtime);
	$backupfolpath=$backuprecent_path . "$todaysdate/$backupfoldername";
}
else
{	$backupfolpath=$backuprecent_path . "$backupfoldername";
}

$splitpath=explode("/", $backupfolpath);
$splitpathdisk=array_shift($splitpath);
CreateDirs($splitpath, $splitpathdisk);

						
//$neededfols=array("localpath_of__abdesktop_data_folder", "backuprecent_path", "backupfolpath");
//MakeNeededFols($neededfols);

?>


<html><head><title>ABDesktop - Made Backup of Recently Modified Records</title>
<link rel=stylesheet href='../files/css/f.css' type='text/css'>
</head>
<body><center>
<?php
AllOrganizerNavLinks();
?>
<p>
<h1>Made Backup of Recently Modified Records</h1>


<?php

echo "<p><big>Backup location:<br><a href=\"file://localhost/$backupfolpath\">$backupfolpath</a></big><p><br>";

$dbvars=array("link", "idea", "file");
$newdbvars=array();
foreach ($dbvars as $dbvar)
{	if (${$dbvar} == false)
	{	continue;
	}
	
	$arrname="$dbvar" . "_arr";
	${$arrname}=explode("; ", ${$dbvar} );
	array_push($newdbvars, $dbvar);
}
$dbvars=$newdbvars;

require ("lib-rootstuff.php");

echo "<big>Backed up some DBs of these types:<p>";

foreach ($dbvars as $dbvar)
{	
	$dispdbvar=ucwords($dbvar);
	$thesetypes .= "$dispdbvar, ";
	
}
$thesetypes=TrimComma($thesetypes);
echo "$thesetypes</big>";




foreach ($dbvars as $dbvar)
{	$arrname="$dbvar" . "_arr";
	if ($dbvar=="link")
	{	$prefix="url";
	}
	else
	{	$prefix=$dbvar;
	}
	
	$idtype=$prefix . "_id";
	$infotable=$prefix . "info";
	$tablearr=$prefix . "_tables";
	
	foreach (${$arrname} as $thisdb)
	{
		$thisdb_backup_filepath=$backupfolpath . "/$thisdb-RecordsSince---$last_complete_backup_date_for_file_labels.txt";
		$disptype=ucwords($dbvar);
		$handle=ConnectAsRoot($thisdb);
		$query_to_issue="SELECT * from $infotable WHERE $infotable.whenmodified >= '$date_to_search_for' ORDER BY $idtype ASC";
		echo "<p><br><hr width=25%><p><big>$disptype Database: $thisdb</big><br>$query_to_issue<p>";
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		
		$numofresults=mysql_num_rows($query_result);
		if ($numofresults>0)
		{	echo "Modified records found: $numofresults ";
			if ($prefix!="file")
			{	unset($item_ids);
				GetItemIds($query_result, $idtype);
			}
			else
			{	GetFileIdsAndImageIds($query_result);
			}
		
			MakeOutputQueries($query_result, $infotable, $thisdb_backup_filepath);
			
			PrintArr(${$tablearr}, "$thisdb - $tablearr");
		
			foreach (${$tablearr} as $thistable)
			{	if ($thistable=="imageinfo")
				{	$item_idstring=$image_idstring;
				}
				
				if ($item_idstring)
				{	
				
					$query_to_issue="SELECT * from $thistable WHERE $idtype IN ($item_idstring)";
					echo "<p> $query_to_issue <p>";  //Commenting this line out causes an internal server error 500 in Hiawatha/Puppy... 08:46 05/08/2011  02:01 05/24/2011.  which probably results from it timing out... it probably already would have displayed that error if the big query text didn't somehow make the page stop loading... 
					$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
					$numofresults=mysql_num_rows($query_result);
					if ($numofresults>0)
					{	echo "<b>Outputting $thistable</b><p><br>";
						MakeOutputQueries($query_result, $thistable, $thisdb_backup_filepath);
					}
				}
			}
			
		}
	}	
}

$last_file_path=$backupfolpath . "/Confirmation--$nowdate--Backup Recent Completed.txt";
AppendToFile($last_file_path, "Yep, it worked.");

function MakeOutputQueries(&$query_result, $table, $outputpath)
{
	$fields=mysql_field_array($query_result);
	$querychunk=0;
	$prevquerychunk=-1;
	$sqlvars=implode($fields, ", ");
	
	while ($info = mysql_fetch_array($query_result) )
	{	array_walk($info,'CleanInput');
		if ($prevquerychunk<$querychunk)
		{	
			$output_query[$querychunk] = "$semicolon\n\nREPLACE INTO
			$table ($sqlvars)

			VALUES\n\n";
			$prevquerychunk=$querychunk;
			$semicolon=";";
		}
		$output_query[$querychunk] .= " (";

		foreach ($fields as $field)
		{	${$field}=$info[$field];
			${$field}=EncloseOrNull(${$field}, "'");
			$output_query[$querychunk] .= "${$field}, ";
		}
		$output_query[$querychunk] = substr($output_query[$querychunk], 0, -2);
		$output_query[$querychunk] .= "), ";
		
		$len=strlen($output_query[$querychunk]);
		
		if ($len>50000)	//If the insert query reaches over 50 KB, then, we start another.
		{
			$output_query[$querychunk] = substr($output_query[$querychunk], 0, -2);
			$output_query[$querychunk] .= "  ";
			$prevquerychunk=$querychunk;
			$querychunk++;
		}
	}
	
	$finaloutput_query=implode(" ", $output_query);
	$finaloutput_query = substr($finaloutput_query, 0, -2);
	$finaloutput_query .=";\n\n";
	AppendToFile($outputpath, $finaloutput_query);
		
}


function GetItemIds(&$query_result, $idtype)
{	
	global $item_ids, $item_idstring;
	
	$z=0;
	while ($info = mysql_fetch_array($query_result) )
	{
		$item_ids[$z+1]=$info[$idtype];		
		$z++;
	}
	$item_idstring=implode(",",$item_ids);
	mysql_data_seek($query_result,0);
	
}
function GetFileIdsAndImageIds(&$query_result)
{	global $file_ids, $file_idstring, $image_ids, $image_idstring;

	while ($info = mysql_fetch_array($query_result) )
	{
		$file_ids[$z+1]=$info[file_id];
		$thisextcat=$info[extcat];
		if ($thisextcat=="Image")
		{
			$image_ids[$z+1]=$info[file_id];
		}
		$z++;
	}
	$file_idstring=implode(",",$file_ids);

	if ($image_ids)
	{
		$image_idstring=implode(", ",$image_ids);
	}
	mysql_data_seek($query_result,0);
}

AllOrganizerNavLinks();