<?php
$current_organizer="file";
require ("../lib-abdesk.php");

CheckCookie();

$errorvarname="output_folder_structure_error";

session_start();


require ("../lib-files.php");

function GoBackToFormWithError($err)
{	global $errorvarname, $file_db_to_use;
	$_SESSION[$errorvarname]=$err;
	header("Location: file_adder_form.php?db=$file_db_to_use");
	exit;
}

if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
	ini_set("max_execution_time", "$phpmaxexec");
	//echo ini_get("memory_limit");
}


	$add=$_POST[add];
	$edited=$_POST[edited];

if (!$add && !$edited)	//Then it was a GET and not a POST
{	
	$add_dirfiles=$_GET[a];
	$make_tns=$_GET[tn];
	$make_ico_tns=$_GET[icotn];
	$thispath=$_GET[p];
	$make_bmp_tns=$_GET[b];
	$disknick=$_GET[dn];
	$db=$_GET[db];
	if ($db)
	{
		$file_db_to_use=$db;
	}
}
else 	// It was a POST after all
{
	$varstoget_fromform=array("thispath", "add_dirfiles", "make_tns", "make_ico_tns", "make_bmp_tns", "editquery", "disknick", "radiobox_selected_file_db");

	foreach ($varstoget_fromform as $varname)
		{
			${$varname}=$_POST[$varname];
//In case the user gets sent back to the form, this makes it so their original
//input is preserved:
			$_SESSION[$varname]=$_POST[$varname];
		}
	$file_db_to_use=$radiobox_selected_file_db;
}

if (!$file_db_to_use)
{	
	GoBackToFormWithError("no db selected");
	exit;
}


require ("lib-output_folder_structure-orig.php");

$handle=ConnectToDb($file_db_to_use, "dont die");

list($array_of_unpaired_folder_paths_from_db, $array_of_unpaired_folder_paths_from_db_with_disks, $array_of_disknicks_of_unpaired_folder_paths_from_db, $num_of_paths)=GetUnpairedFolderPathsFromDB($handle);

echo "<html><head><title>ABDesktop $file_db_to_use Folder Structure - </title>
<link rel=stylesheet href=\"css/f.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style></head><body><center>";

AllOrganizerNavLinks();

echo "<h1>ABDesktop File DB - Output Folder Structure</h1>
<p>";
PrintDBHeader("file");

echo "<p>Num of paths: $num_of_paths";

/*PrintArr($array_of_unpaired_folder_paths_from_db);
PrintArr($array_of_unpaired_folder_paths_from_db_with_disks);
PrintArr($array_of_disknicks_of_unpaired_folder_paths_from_db);
*/

echo "</center>";

$pathnum=0;
$prev_path="//";
$link_label=null;
$link_url=null;
$prev_num_of_path_parts=0;

while ($pathnum<$num_of_paths)
{
	$this_path=$array_of_unpaired_folder_paths_from_db[$pathnum];
	$link_class="";
	
	if ($this_path=="")
	{
		$link_url="file://localhost/" . $array_of_unpaired_folder_paths_from_db_with_disks[$pathnum];
		$link_label=$array_of_unpaired_folder_paths_from_db_with_disks[$pathnum];
		//echo "Link label: '$link_label' ";
		$num_of_path_parts=1;
	}
	else
	{
		$exploded_path=explode("/", $this_path);
		$num_of_path_parts=count($exploded_path);
		//PrintArr($exploded_path, "$this_path");
	//	echo "Num of path parts: $num_of_path_parts";
		$link_url="file://localhost/" . $array_of_unpaired_folder_paths_from_db_with_disks[$pathnum];
		$link_label=$exploded_path[$num_of_path_parts-1];
	}
	
	if ($num_of_path_parts>$prev_num_of_path_parts)
	{	$repeat_count=$num_of_path_parts-$prev_num_of_path_parts;
	//	echo str_repeat("<ul>ul", $repeat_count);
		echo str_repeat("<ul>", $repeat_count);
	}
	else if ($num_of_path_parts<$prev_num_of_path_parts)
	{	$repeat_count=$prev_num_of_path_parts-$num_of_path_parts;
		echo str_repeat("</ul>", $repeat_count);
		//echo str_repeat("</ul>/ul", $repeat_count);
	}
	
	if ($this_path!=$prev_path)
	{
		//echo "<li>$link_label";
		$raw_url_encoded_path=rawurlencode($this_path);
		echo "<li><big><a href=\"make_solamnia_folders.php?dir=$raw_url_encoded_path&disk=S\">$link_label</a></big>";
		
	}
	
	//else if ($this_path==$prev_path)
	//{	//echo "This path: '$this_path' Prev path: '$prev_path' ";
		$link_label=$array_of_disknicks_of_unpaired_folder_paths_from_db[$pathnum];
		$link_class="class='altdisknick'";
		//echo " <small>(";
//	}
	
	echo " - <a $link_class href='$link_url'>$link_label</a>";
	
	/*if ($this_path==$prev_path)
	{
		echo ")</small>";
	}*/
	$prev_path=$this_path;
	$prev_num_of_path_parts=$num_of_path_parts;
	$pathnum++;
}

$repeat_count=$num_of_path_parts;
echo str_repeat("</ul>", $repeat_count);

echo "<center>";
AllOrganizerNavLinks();
