<?php

$max_tn_width=200;
$max_tn_height=200;



if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
}


$tnableimageformats=array("bmp", "gif", "jpg", "jpeg", "png", "ico");



function RemoveFileLocalhost($path)
{
	$plainpath=explode("file://localhost/",$path);
	$res=$plainpath[1];

	return $res;
}



function EncloseOrNullFileDetails()
{
	$varstoenclose=array("disk", "parentdirs", "itemtype", "filename", "ext", "extcat", "paired", "pairedname");

	foreach ($varstoenclose as $var)
	{	global ${$var};
		${$var}=EncloseOrNull(${$var}, "'");
	}
}



function EncloseOrNullFileSizeAndDates()
{	$varstoenclose=array("filesize", "filelm", "filecr");

	foreach ($varstoenclose as $var)
	{	global ${$var};
		${$var}=EncloseOrNull(${$var}, "'");
	}
}



function EncloseOrNullOtherDetails()
{	$varstoenclose=array("importdate", "contentsimported", "repository", "privacylevel", "licensetype");
	foreach ($varstoenclose as $var)
	{	global ${$var};
		if (${$var}!="now()")
		{
			${$var}=EncloseOrNull(${$var}, "'");
		}
	}
}



function EncloseOrNullImageDetails()
{	
	$varstoenclose=array("imagewidth", "imageheight", "imagearea", "aspectratio", "reverse_aspectratio", "wideortall", "showthumbnail", "hasthumbnail");
	foreach ($varstoenclose as $var)
	{	global ${$var};
		${$var}=EncloseOrNull(${$var}, "'");
	}
}



function GetFileSizeAndDates($diskpath, $should_shift_ahead_12_hours=false)
{	global $filelm, $filecr, $filesize;

	$itemtype=GetItemType($diskpath);
	echo "Diskpath: $diskpath";
	
	$sizendates = stat($diskpath);

	$filelm=$sizendates['mtime'];
	$filecr=$sizendates['ctime'];

//	echo "Raw filelm: $filelm  Raw filecr: $filecr <p>";
	
	$preprocfilelm=date("Y-m-d H:i:s", $filelm);
	$preprocfilecr=date("Y-m-d H:i:s", $filecr);
	
//	echo " PreProcessed filelm: $preprocfilelm  PreProc filecr: $preprocfilecr<p>";
	
	if ($should_shift_ahead_12_hours)
	{
		$filelm = $filelm + (12*3600);
		$filecr = $filecr + (12*3600);
	}
	$filelm=date("Y-m-d H:i:s", $filelm);
	$filecr=date("Y-m-d H:i:s", $filecr);
	
	//echo " filelm: $filelm  PreProc filecr: $filecr<p>";
	
	if ($itemtype!="Dir")
	{
		$filesize=$sizendates['size'];
		echo "Filesize: $filesize" ;
	}
	else
	{	$filesize="";
	}
}



function CleanFileDetails()
{	global $parentdirs, $filename, $ext, $pairedname;

	CleanInput( $parentdirs );
	CleanInput( $filename );
	CleanInput( $ext) ;
	CleanInput( $pairedname) ;
}



function CleanAndEncloseOrIsNullPathinfo()
{	global $disk, $parentdirs, $filename, $ext, $cleandisk, $cleanparentdirs, $cleanfilename, $cleanext;

	$varstoclean=array("disk", "parentdirs", "filename", "ext");
	
	foreach($varstoclean as $var)
	{
		$cleanvar="clean$var";
		${$cleanvar}=${$var};
		CleanInput(${$cleanvar});
		${$cleanvar}=EncloseOrIsNull($var, ${$cleanvar}, "'");
	}
}



function CleanPathinfo()
{	global $disk, $parentdirs, $filename, $ext, $cleandisk, $cleanparentdirs, $cleanfilename, $cleanext;

	$varstoclean=array("disk", "parentdirs", "filename", "ext");
	
	foreach($varstoclean as $var)
	{
		$cleanvar="clean$var";
		${$cleanvar}=${$var};
		CleanInput(${$cleanvar});
	}
}



function VarArrays()
{	
	$vars=array("disk", "parentdirs", "filename", "ext", "itemtype");
	
	foreach ($vars as $var)
	{	global ${$var};
		${$var}=array();
	}
}



function GetDiskAndDirs($diskpath)
{//	echo "Diskpath: $diskpath" ;
	$pathparts = pathinfo($diskpath);
	//PrintArr($pathparts);
	$singlecolonloc=strpos($diskpath, ":");
	$disk=substr($diskpath, 0, $singlecolonloc);
	
	$parentdirs=$pathparts['dirname'];
	$parentdirs = str_replace("\\", "/", $parentdirs);
	//echo "Test: $parentdirs";
	$singlecolonslashloc=strpos($parentdirs, ":");
//	echo "Slashloc: $singlecolonslashloc ";
	$parentdirs=substr($parentdirs, $singlecolonslashloc+2);
	//echo "Test: $parentdirs";
	$basename=$pathparts['basename'];
	
	$singlecolonloc=strpos($basename, ":");
	if ($singlecolonloc)
	{	$basename="";
	}
	//echo "Basename: $basename ";
	if ($parentdirs)
	{	$parentdirs .= "/";
	}
	$alldirs = $parentdirs . $basename;
	//	echo "Test: $parentdirs";
	$arr=array($disk, $alldirs);
	//PrintArr($arr);
	return $arr;
}



function GetPathinfo($diskpath)
{	global $disk, $parentdirs, $filename, $ext, $itemtype, $platform_mode, $linux_mount_point_without_last_slash, $string_length_of_the_paths_linux_mount_point, $the_paths_windows_drive_letter;

	$pathparts = pathinfo($diskpath);

	$itemtype=GetItemType($diskpath);
	if (!$itemtype)
	{	return false;
	}
	//PrintArr($pathparts);
	if ($platform_mode=="Windows")
	{
		$singlecolonloc=strpos($diskpath, ":");
		$disk=substr($diskpath, 0, $singlecolonloc);
	}
	if ($platform_mode=="Linux")
	{	$disk=$the_paths_windows_drive_letter;
	}
	
	$parentdirs=$pathparts['dirname'];
	$parentdirs = str_replace("\\", "/", $parentdirs);
	
	if ($platform_mode=="Windows")
	{
		$singlecolonslashloc=strpos($parentdirs, ":");
		$parentdirs=substr($parentdirs, $singlecolonslashloc+2);
	}
	if ($platform_mode=="Linux")
	{
		if ($linux_mount_point_without_last_slash)
		{
			$mtpt_pos=strpos($parentdirs, $linux_mount_point_without_last_slash);
			if ($mtpt_pos!==false)
			{	
				$parentdirs=substr($parentdirs, $string_length_of_the_paths_linux_mount_point);
			}
		}
		else
		{
			$parentdirs=ltrim($parentdirs, "/");
		}
	}
	//echo "Parentdirs: $parentdirs  Itemtype: $itemtype";
	
	if ($itemtype=="Dir")
	{	$filename=$pathparts['basename'];
	}
	else
	{	
		$basename=$pathparts['basename'];
		
		list($thisfn, $thisext)=GetFNExt($basename);
		$ext=$thisext;
		$filename=$thisfn;
	}
	
	//08:49 05/12/2011.  In Linux, $disk and $parentdirs "retrieved"
	//by this function are useless and must be overwritten later/elsewhere.  
	//$filename, $itemtype, and $ext are fine, though.  
	return true;
}



function MakeThumbnail($diskpath, $ext, $id, $temp=false, $img=false, $makegif=false, $resize=true)
{	global $bmp_library_installed, $file_db_to_use;
	$lowercasext=strtolower($ext);
	
	if ($img==false)
	{
		if ($lowercasext=="jpg" || $lowercasext=="jpeg")
		{	$img="";
			$img=imagecreatefromjpeg($diskpath);
		}
		else if ($lowercasext=="png")
		{	$img=imagecreatefrompng($diskpath);
		}
		else if ($lowercasext=="gif")
		{	$img=imagecreatefromgif($diskpath);
		}
		else if ($lowercasext=="bmp" && $bmp_library_installed==true)
		{	$img=imagecreatefrombmp($diskpath);
		}
		else
		{	return false;
		}
	}
	//else
//	{	$img=$imgdata;
	//	imagedestroy( $tmp_img);
	//}
	if (!$img)
	{	return false;
	}

	global  $max_tn_width, $max_tn_height;
	

	$width = imagesx( $img );
    $height = imagesy( $img );
	
	//echo "Width: $width Height: $height  Max Tn: $max_tn_width  $max_tn_height ";
	if ($width>=$height)
	{	$newwidth=$max_tn_width;
		$newheight=floor(($max_tn_width*$height)/$width);
	}
	else if ($height>$width)
	{	$newheight=$max_tn_height;
		$newwidth=floor(($max_tn_height*$width)/$height);
	}

	// create a new temporary image
	if ($resize==true)
	{
		$tmp_img = imagecreatetruecolor( $newwidth, $newheight );

    // copy and resize old image into new image
		imagecopyresized( $tmp_img, $img, 0, 0, 0, 0, $newwidth, $newheight, $width, $height );
	}
	
	if ($temp)
	{	$finaloutputpath=GetThumbnailPath($id, true, $makegif);
	}
	else
	{
		$finaloutputpath=GetThumbnailPath($id, false, $makegif);
	}

	
    // save thumbnail into a file
	if (!$makegif)
	{	if ($resize==true)
		{
			imagejpeg( $tmp_img, "$finaloutputpath" );
		}
		else
		{	imagejpeg( $img, "$finaloutputpath" );
		}
	}
	else
	{	if ($resize==true)
		{	imagegif( $tmp_img, "$finaloutputpath" );
		}
		else
		{	imagegif( $img, "$finaloutputpath" );
		}
	}
	if ($resize==true)
	{
		imagedestroy( $tmp_img);
	}
	imagedestroy( $img);
	return true;
}



function GetLargestIconDetails($icon)
{
	$total_icons = $icon->TotalIcons();
//	echo "Total icons: $total_icons ";
	$index_of_largest_icon=-1;
	$prev_largest_byte_size=0;
							
	for ($iconinc=0; $iconinc<$total_icons; $iconinc++)
	{	$iconinfo=$icon->GetIconInfo($iconinc);
		$this_sizeinbytes=$iconinfo[SizeInBytes];
		$this_height=$iconinfo[Height];
		$this_width=$iconinfo[Width];
		if ($this_height<1)
		{	continue;
		}
		if ($this_sizeinbytes > $prev_largest_byte_size)
		{	$index_of_largest_icon=$iconinc;
			$prev_largest_byte_size = $this_sizeinbytes;
			$largest_height=$this_height;
			$largest_width=$this_width;
		}
								
	}
	//echo "This_width: $this_width, $this_height, $index_of_largest_icon ";
	$arr=array($largest_height, $largest_width, $index_of_largest_icon);
	
	return $arr;
	
}



function GetFileDetails($diskpath)
{	global $disk, $parentdirs, $filename, $ext, $extcat, $itemtype, $paired, $pairedname, $aspectratio, $reverse_aspectratio, $imagewidth, $imageheight, $imagearea, $wideortall, $showthumbnail, $hasthumbnail, $bmp_library_installed, $tnableimageformats, $platform_mode, $the_paths_linux_mount_point;
	
	//$filexists=GetPathinfo($diskpath);
	$filexists=file_exists($diskpath);
	
	
	if (!$filexists)
	{	//echo "no file exists";
		return false;
	}
	#echo "Setting paired = no";
	
	$paired="n";	//No by default unless an accompanying file/fol is found.
//	echo "in here Itemtype $itemtype ";
	if ($itemtype=="File")
	{//	echo "it's a file";
		$lowercasext=strtolower($ext);
		if ($ext)
		{
			$extcat=GetExtCat($lowercasext);
		}
		else
		{	$extcat="No Extension";
		}
		//echo "EXT: $ext";
		
		if ($platform_mode == "Windows")
		{
			$possiblefolpath=$disk . ":/" . $parentdirs . "/" . $filename . "_files";
		}
		else if ($platform_mode=="Linux")
		{	$possiblefolpath=$the_paths_linux_mount_point . $parentdirs . "/" . $filename . "_files";
			//echo "Possiblefolpath: $possiblefolpath ";
		}
		if (file_exists($possiblefolpath))
		{	
			if (is_dir($possiblefolpath))
			{	$paired="y";
				$pairedname=$filename . "_files";
			}
		}
		
	//	echo "lowercasext: $lowercasext ";
		
		if (in_array($lowercasext, $tnableimageformats) )
		{	//echo "<hr>TNable image formats<p>";
			if ($lowercasext!="gif" && $lowercasext!="jpg" && $lowercasext!="jpeg" && $lowercasext!="png" && $lowercasext!="bmp" && $lowercasext!="ico")
			{	$showthumbnail="n";
				$hasthumbnail="n";
			}//&& $bmp_library_installed==true)
			if ($lowercasext=="gif" || $lowercasext=="jpg" || $lowercasext=="jpeg" || $lowercasext=="png" || $lowercasext=="bmp" || $lowercasext=="ico" )
			{	$showthumbnail="y";
				$hasthumbnail="y";
			//	if ($lowercasext=="bmp" && $bmp_library_installed==false)
			//	{	$hasthumbnail="n";
			//	}
			}
			
			if ($lowercasext!="ico")
			{
				list($width, $height) = getimagesize($diskpath);
			}
			else
			{	require_once("../lib-class.ico.php");
				$temp_icon=new Ico($diskpath);
				
				list($width, $height) = GetLargestIconDetails($temp_icon);
				
				//echo "Width: $width $height ";
			}
			//echo "Width: $width $height ";
			$aspectratio=number_format($width/$height, 3);
			$reverse_aspectratio=number_format($height/$width,3);
			
			//echo "Wide or tall: $wideortall ";
			if ($width<$height)
			{
				$wideortall="t";
			}
			else if ($width>$height)
			{
				$wideortall="w";
			}
			else if ($width==$height)
			{	$wideortall="s";	//square
				$reverse_aspectratio=number_format(1, 3);
			}

			$imageheight=$height;
			$imagewidth=$width;
			$imagearea=$width*$height;
		}

	}
	else if ($itemtype=="Dir")
	{	if ($ext)
		{	$fulldirname=$filename . "." . $ext;
		}
		else
		{	$fulldirname=$filename;
		}
		$explosion=explode("_", $fulldirname);

		if ($explosion[( count($explosion)-1 ) ]=="files")
		{	array_pop($explosion);

			$possiblefilename=implode("_", $explosion);
			if ($platform_mode == "Windows")
			{
				$possiblepathstart=$disk . ":/" . $parentdirs . "/";
			}
			else if ($platform_mode == "Linux")
			{	$possiblepathstart=$the_paths_linux_mount_point . $parentdirs . "/";
			}
			$possiblefilepathhtm=$possiblepathstart . $possiblefilename . ".htm";
			$possiblefilepathhtml=$possiblepathstart . $possiblefilename . ".html";
			$possiblefilepathshtml=$possiblepathstart . $possiblefilename . ".shtml";
			if (file_exists($possiblefilepathhtm) || file_exists($possiblefilepathhtml) || file_exists($possiblefilepathshtml))
			{	$paired="y";
			}

			if ( file_exists($possiblefilepathhtm) )
			{	$pairedname=$possiblefilenamehtm;
			}
			else if ( file_exists($possiblefilepathhtml) )
			{	$pairedname=$possiblefilenamehtml;
			}
			else if ( file_exists($possiblefilepathshtml) )
			{	$pairedname=$possiblefilenameshtml;
			}
			else
			{	$pairedname="";
			}
		}
	}
	return true;
}



function BackToForwardSlashes($inp)
{	if (strpos($inp, "\\"))
	{	$inp = str_replace("\\", "/", $inp);
		//$inp = AddFileLocalhost($inp);
	}
	return $inp;
}



function ConvertFirefoxFormatLocalUrl($inp)
{	if (strpos($inp, "file:///")!==false)
	{
		$inp = str_replace("file:///", "file://localhost/", $inp); //12:47 PM, 3/17/2011. ereg_replace removed.
		//$inp=Convert20ToSpaces($inp);
	}
	return $inp;
}



function AddFileLocalhost($inp)
{	$inp = "file://localhost/" . $inp;
	return $inp;
}



function FileLocalhostHere($inp)
{	$res=strpos($inp, "file://localhost/");
	if ($res===false)
	{	return false;
	}
	return true;	
}



function SingleColonSlashPresentIn($inp)
{
	$pos=strpos($inp, ":/");
	if ($pos!==false)
	{
		return true;
	}
	else 
	return false;
}



/*function SingleColonSlashAbsentIn($inp)
{
	if (strpos($inp, ":/")!==false)
	{	return false;
	}
	else return true;
}*/



function ListerProcessRawFilepath($rawfilepath)
{	global $handle, $error;

	/*02:38 05/11/2011.  looks like the difference between ListerProcessRawFilepath
	and ProcessRawFilepath is, it returns false with an error instead of doing the GoBackToFormWithError and exiting immediately.  02:41 05/11/2011.  oh, and ProcessRawFilepath has global $disk;, while ListerProcessRawFilepath doesn't...
	*/
	
	//Isn't going to tamper with %20's, so, make sure you don't use them unless
	//they're really a part of the file name and not just taking the place of a space.
	//Really, you're better off renaming all files which have %20's in the file name
	//since they tend to confuse web browsers.

	$convertedfilepath = trim ($rawfilepath);
	$convertedfilepath = BackToForwardSlashes($convertedfilepath);
	$convertedfilepath = ConvertFirefoxFormatLocalUrl($convertedfilepath );

	if (strpos($convertedfilepath, "file://localhost/")!==false)
	{	$convertedfilepath=str_replace("file://localhost/", "", $convertedfilepath);
		echo "ARGH";
		exit;
		if ($platform_mode == "Linux")
		{
			$convertedfilepath = "/" . $convertedfilepath;
		}
	}
	//04:25 05/11/2011.  if file://localhost/ is there, and this is Linux mode,
	//then, we want to leave a / at the beginning of the path.
	
	//First, we strip off file://localhost if it's already there.
	 //12:48 PM, 3/17/2011.  ereg_replace removed
	
	$convertedfilepath=StripExtraSlashes($convertedfilepath);

	if ($platform_mode == "Windows")
	{	
		if (!SingleColonSlashPresentIn($convertedfilepath)) 
			//An indication that the user didn't mention a drive, or just forgot the colon
		{	DisplayWithError($convertedfilepath);
			$error="no colonslash";
			return false;
		}
	}

	//Then we strip out any extra, needless slashes the user might have put in.
	$convertedfilepath=StripExtraSlashes($convertedfilepath);

	//There always has to be a : before the first /.
	$firstslashloc=strpos($convertedfilepath, "/");
	$firstcolon=substr($convertedfilepath, $firstslashloc-1, 1);

	if ($firstcolon!=":")
	{	$error="misplaced colonslash";
		return false;
		
	}
	
	if (SingleColonSlashPresentIn($convertedfilepath))	//If :/ present:

	{	//We then find out where the :/ is.
		$singlecolonslashloc=strpos($convertedfilepath, ":/");

		//If the :/ is 1 char ahead of the beginning of the string,
		//there's probably a drive letter before it, but we'll check
		//to make sure.

		if ($singlecolonslashloc==1)
		{	$drivename=substr($convertedfilepath, 0, 1);
			if (!preg_match("/[A-z]/", $drivename))
				//Not a drive letter if it's not A-Z or a-z, so
				//we go back to the form with an error.
			{	$error="drive letter";
				return false;
			}
			else	//If it is a drive letter, we make it uppercase.
			{	//$drivename=strtoupper($drivename);
				//$convertedfilepath=substr($convertedfilepath, 3);
			}
		}
		else if ($singlecolonslashloc==0)
		{	$error="drive letter";
			return false;
		}
		else //if :/ is anywhere else...
		{	$drivename=substr($convertedfilepath, 0, $singlecolonslashloc);
			//$convertedfilepath=substr($convertedfilepath, $singlecolonslashloc);
		}
	}
	//global $disk;
	
	$disk=$drivename;
	
		//We add file://localhost, and the capitalized drive
		//letter.
	$convertedfilepath = $convertedfilepath;
	
	//Then we count how many :/'s are there.
	$numofsinglecolonslash=substr_count($convertedfilepath, ":/");
	
	//There should never be more than one :/, so if there is, we 
	//send the user back to the form.
	if ($numofsinglecolonslash>1)
	{	$error="too many colonslashes";
		return false;
	}

	$convertedfilepath=rtrim($convertedfilepath,"/");

	//strips out /'s.
	$str=preg_replace("/(\/)+/", ' ', $convertedfilepath);
	
	//If the path contains :*?"<>| - character forbidden in Windows file or dir names -
	//it bounces the user  back to the form.  ( \ / are also forbidden but those get
	//stripped out or converted so we don't look for them )
	$str=substr($convertedfilepath, $singlecolonslashloc+2);

	$badchars=preg_match_all("/:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	$matchstr=implode(" ", $matches[0]);

	if ($badchars>0)
	{	DisplayWithError($matchstr);
		$error="badchars";
		return false;
	}
	
	return $convertedfilepath;
}



function ProcessRawFilepath($rawfilepath)
{	global $handle, $platform_mode;
	
	//Isn't going to tamper with %20's, so, make sure you don't use them unless
	//they're really a part of the file name and not just taking the place of a space.
	//Really, you're better off renaming all files which have %20's in the file name
	//since they tend to confuse web browsers.

	$convertedfilepath = trim ($rawfilepath);
	$convertedfilepath = BackToForwardSlashes($convertedfilepath);
	$convertedfilepath = ConvertFirefoxFormatLocalUrl($convertedfilepath );

	if (strpos($convertedfilepath, "file://localhost/")!==false)
	{	
		//We strip off file://localhost if it's already there.
		$convertedfilepath=str_replace("file://localhost/", "", $convertedfilepath);
		
		if ($platform_mode == "Linux")
		{	//04:25 05/11/2011.  if file://localhost/ is there, and this is 
			//Linux mode, then, we want to leave a / at the beginning of the path.
			$convertedfilepath = "/" . $convertedfilepath;
		}
	}
	
	
	
	//First, we strip off file://localhost if it's already there.
	//$convertedfilepath=str_replace("file://localhost/", "", $convertedfilepath); //12:48 PM, 3/17/2011.  ereg_replace removed
	
	$convertedfilepath=StripExtraSlashes($convertedfilepath);

	if ($platform_mode == "Windows")
	{	
		if (!SingleColonSlashPresentIn($convertedfilepath)) 
			//An indication that the user didn't mention a drive, or just forgot the colon
		{	DisplayWithError($convertedfilepath);
			GoBackToFormWithError("no colonslash");
			exit;
		}
	}
	else if ($platform_mode=="Linux")
	{
		//04:15 05/11/2011. Check if the first character is a slash.
		$firstchar=substr($convertedfilepath, 0, 1);
		if ($firstchar!="/")
		{	DisplayWithError($convertedfilepath);
			GoBackToFormWithError("no slash at start");
			exit;
		}
	}

	//Then we strip out any extra, needless slashes the user might have put in.
	$convertedfilepath=StripExtraSlashes($convertedfilepath);
	//03:54 05/11/2011. do i really need two of those StripExtraSlashes lines?
	
	//There always has to be a : before the first /.
	//03:57 05/11/2011. with Windows file paths, that is.
	if ($platform_mode=="Windows")
	{	
		$firstslashloc=strpos($convertedfilepath, "/");
		$firstcolon=substr($convertedfilepath, $firstslashloc-1, 1);

		if ($firstcolon!=":")
		{	GoBackToFormWithError("misplaced colonslash");
			exit;
		}
	
	
		if (SingleColonSlashPresentIn($convertedfilepath))	//If :/ present:
		
		{	//We then find out where the :/ is.
			$singlecolonslashloc=strpos($convertedfilepath, ":/");

			//If the :/ is 1 char ahead of the beginning of the string,
			//there's probably a drive letter before it, but we'll check
			//to make sure.

			if ($singlecolonslashloc==1)
			{	$drivename=substr($convertedfilepath, 0, 1);
				if (!preg_match("/[A-z]/", $drivename))
					//Not a drive letter if it's not A-Z or a-z, so
					//we go back to the form with an error.
				{	GoBackToFormWithError("drive letter");
					exit;
				}
				else	//If it is a drive letter, we make it uppercase.
				{	//$drivename=strtoupper($drivename);
					//$convertedfilepath=substr($convertedfilepath, 3);
				}
			}
			else if ($singlecolonslashloc==0)
			{	GoBackToFormWithError("drive letter");
				exit;
			}
			else //if :/ is anywhere else...
			{	$drivename=substr($convertedfilepath, 0, $singlecolonslashloc);
				//$convertedfilepath=substr($convertedfilepath, $singlecolonslashloc);
			}
		}
	}
	//global $disk;		//05:31 05/11/2011. Hopefully we can do without this line...
	
	$disk=$drivename;
	
		//We add file://localhost, and the capitalized drive
		//letter.  04:11 05/11/2011.  actually, looks like we don't.
	$convertedfilepath = $convertedfilepath;
	
	
	if ($platform_mode=="Windows")
	{	
		//Then we count how many :/'s are there.
		$numofsinglecolonslash=substr_count($convertedfilepath, ":/");
	
		//05:52 05/11/2011. In "Windows" mode...
		//There should never be more than one :/, so if there is, we 
		//send the user back to the form.
		if ($numofsinglecolonslash>1)
		{	GoBackToFormWithError("too many colonslashes");
			exit;
		}
	}

	$convertedfilepath=rtrim($convertedfilepath,"/");

	//strips out /'s.
	//05:58 05/11/2011. the  below line seems like it just gets overwritten,
	//so, guess I'll comment it out... 
	//$str=preg_replace("/(\/)+/", ' ', $convertedfilepath);
	
	//If the path contains :*?"<>| - character forbidden in Windows file or dir names -
	//it bounces the user  back to the form.  ( \ / are also forbidden but those get
	//stripped out or converted so we don't look for them )
	$str=substr($convertedfilepath, $singlecolonslashloc+2);

	$badchars=preg_match_all("/:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	$matchstr=implode(" ", $matches[0]);

	if ($badchars>0)
	{	if ($platform_mode=="Windows")
		{	DisplayWithError($matchstr);
			GoBackToFormWithError("badchars");
			exit;
		}
		//If in Linux mode, should probably just warn the user somehow.
	}
	
	return $convertedfilepath;
}



function MakeFilepathClean($filepath)
{
	$cleanfilepath=$filepath;
	
	CleanInput($cleanfilepath);

	return $cleanfilepath;
}



function UnsetFileDetails()
{	
	$varstounset=array("filesize", "extcat", "itemtype", "disk", "parentdirs", "filename", "ext", "filelm", "filecr", "paired", "pairedname");
	//"repository", "contentsimported", "privacylevel", "licensetype", "whenadded", "importdate")
	foreach ($varstounset as $var)
	{	global ${$var};
		${$var}="";
	}
}



function UnsetImageDetails()
{	
	$varstounset=array("imagewidth", "imageheight", "imagearea", "aspectratio", "reverse_aspectratio", "wideortall", "showthumbnail", "hasthumbnail");

	foreach ($varstounset as $var)
	{	global ${$var};
		${$var}="";
	}
}



function GetExtCat($inp)
{	switch ($inp)
	{
		case "png": 
		case "jpg": 
		case "jpeg":
		case "bmp":
		case "art":
		case "xcf":
		case "psd":
		case "gif":	$res="Image"; break;
		case "ico": $res="Icon"; break;

		case "mid": 
		case "wav":
		case "aiff":
		case "spc": 
		case "it":
		case "wma":
		case "mp3": $res="Audio"; break;

		case "wmv":
		case "flv":
		case "avi":
		case "mpg":
		case "mpeg": $res="Video"; break;
		
		case "sf2": $res="SoundFont"; break;
		
		case "se1": $res="Swiss Ephemeris"; break;
		
		case "doc": 
		case "rtf":
		case "odt": 
		case "pdf": 
		case "txt": $res="Text"; break;
		
		case "ttf": $res="Font"; break;
		
		case "c":
		case "h":
		case "pl": 
		case "py":
		case "cpp":
		case "bas":
		case "inf":
		case "icl":
		case "ahk":
		case "i7x":
		case "php": $res="Source Code"; break;

		case "htm": 
		case "html":
		case "mht":
		case "shtml": $res="Web"; break;
		case "css": $res="Stylesheet"; break;
		
		case "xmind":
		case "mm": $res="Mind Map"; break;
		
		case "xml": $res="XML"; break;

		case "bak": $res="Backup"; break;
		case "m3u": $res="Playlist"; break;

		
		case "z5":
		case "z8": $res="Interactive Fiction";
		
		case "pfc": $res="AOL Email DB"; break;
		case "sxw": $res="OpenOffice Macro"; break;
		case "db": $res="Thumbnail DB"; break;
		case "lnk": $res="Shortcut"; break;
		case "exe": $res="Executable"; break;
		
		case "zip":
		case "rar":	$res="Compressed"; break; 
		
		case "sea":
		case "hqx":
		case "sit": $res="Mac Compressed"; break;
		default: $res="Unknown"; break;
	}
	return $res;
}


