<?php



function CreateBuildableZipFile($path_being_zipped)
{	
	echo "path_being_zipped: $path_being_zipped ";
	
	$final_temp_zip_path=GetFinalTempZipPath($path_being_zipped);
	//list($path_length, $filename)=GetPathLengthAndFinalTempZipPath($path_being_zipped);
	
	//////
	$zip = new ZipArchive;
	$res = $zip->open($final_temp_zip_path, ZipArchive::CREATE);
	if ($res !== TRUE)
	{
		echo "CreateBuildableZipFile Error: Unable to create zip file";
		return false;
	}
	//$arr = array($zip, $path_length);
	$arr = array($zip, $final_temp_zip_path);
//	return $zip;
	return $arr;
}



function GetFinalTempZipPath($path_being_zipped)
{	//global $localpath_for_temp_backup_zips;

	echo "<p><br>Path being zipped: $path_being_zipped <p><br>";
	$path_being_zipped=rtrim($path_being_zipped, "/");
	
//	GetPathLength($path_being_zipped);
	
	$arr_path_being_zipped=explode('/',$path_being_zipped);
	
	$filename=array_pop($arr_path_being_zipped);	//Gets filename with ext
	
	$f=explode('.',$filename);	
	$filename=$f[0]; //Gets filename minus ext
	echo "Current filename: $filename ";
	$filename=( ($filename=='') ? 'backup' : $filename);
	echo "ZIP Filename: $filename<p>";
	$final_temp_zip_path=$path_being_zipped . "/$filename.zip";	//Makes final temp path
	//$final_temp_zip_path=$localpath_for_temp_backup_zips . "/$filename.zip";	//Makes final temp path
	//echo "localpath_for_temp_backup_zips: $localpath_for_temp_backup_zips <p>";
	$fileexists=file_exists($final_temp_zip_path);
	$x=1;
	while ($fileexists)
	{	//$final_temp_zip_path=$localpath_for_temp_backup_zips . "/$filename-($x).zip";
	$final_temp_zip_path=$path_being_zipped . "/$filename-($x).zip";
		$x++;
		$fileexists=file_exists($final_temp_zip_path);
	}
	echo "Final path: $final_temp_zip_path ";
	return $final_temp_zip_path;
}



function GetPathLength($path_being_zipped)
{	$path_being_zipped=rtrim($path_being_zipped, "/");
	$arr_path_being_zipped=explode('/',$path_being_zipped);
	$filename=array_pop($arr_path_being_zipped);
	
	$imploded=implode('/',$arr_path_being_zipped);	//Implodes array
	$imploded .= '/';
	echo "Imploded: $imploded ";
	$path_length=strlen($imploded); //Gets length of imploded path array - path_length
	return $path_length;
}



function AddToZipFile($path_being_zipped, $zip)
{
	$path_length=GetPathLength($path_being_zipped);
	
	if ( is_file($path_being_zipped) )
	{	$zip->addFile($path_being_zipped, substr($path_being_zipped,$path_length) );
	}
	else
	{
		if( !is_dir($path_being_zipped) )
		{
			//$zip->close();
			// @unlink($filename);
			echo 'AddToZipFile Error: File not found';
			return false;
			//exit;
		}
		recurse_zip($path_being_zipped,$zip,$path_length);
	}
	return true;
}



function CloseBuildableZipFile($zip)
{
	$zip->close();
	echo "Closed Zipfile";
}



function MakeZipFile($path_being_zipped)	//Makes a zip file instantly
{	global $localpath_for_temp_backup_zips;
	
	list($zip, $final_temp_zip_path)=CreateBuildableZipFile($path_being_zipped);

	//$zip=CreateBuildableZipFile($path_being_zipped);
	if (!$zip)
	{	echo "MakeZipFile error: No zip file created";
		return false;
	}
	AddToZipFile($path_being_zipped, $zip);
	
	$zip->close();
	return $final_temp_zip_path;
}



function recurse_zip($src,&$zip,$path_length) 
{
        $dir = opendir($src);
        while(false !== ( $file = readdir($dir)) ) 
		{
            if ( ( $file != '.' ) && ( $file != '..' ) ) 
			{
                if ( is_dir($src . '/' . $file) ) 
				{
                    recurse_zip($src . '/' . $file,$zip,$path_length);
                }
                else 
				{
                    $zip->addFile($src . '/' . $file,substr($src . '/' . $file,$path_length));
                }
            }
        }
        closedir($dir);
}


