<?php
$current_organizer="file";
require ("../lib-abdesk.php");

CheckCookie();

$errorvarname="fileadder_error";

session_start();


require ("../lib-files.php");

function GoBackToFormWithError($err)
{	global $errorvarname, $file_db_to_use;
	$_SESSION[$errorvarname]=$err;
	header("Location: file_adder_form.php?db=$file_db_to_use");
	exit;
}

if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
	ini_set("max_execution_time", "$phpmaxexec");
	echo ini_get("memory_limit");
	echo ini_get("max_execution_time");
}


	$add=$_POST[add];
	$edited=$_POST[edited];

if (!$add && !$edited)	//Then it was a GET and not a POST
{	
	$add_dirfiles=$_GET[a];
	$make_tns=$_GET[tn];
	$make_ico_tns=$_GET[icotn];
	$thispath=$_GET[p];
	$make_bmp_tns=$_GET[b];
	$disknick=$_GET[dn];
	$db=$_GET[db];
	$import_dirs_recursively=$_GET[idr];
	
	if ($db)
	{
		$file_db_to_use=$db;
	}
}
else 	// It was a POST after all
{
	$varstoget_fromform=array("thispath", "add_dirfiles", "make_tns", "make_ico_tns", "make_bmp_tns", "editquery", "disknick", "radiobox_selected_file_db", "import_dirs_recursively");

	foreach ($varstoget_fromform as $varname)
		{
			${$varname}=$_POST[$varname];
//In case the user gets sent back to the form, this makes it so their original
//input is preserved:
			$_SESSION[$varname]=$_POST[$varname];
		}
	$file_db_to_use=$radiobox_selected_file_db;
}

if (!$fileadder_enabled)
{	
	GoBackToFormWithError("fileadder inactive");
	exit;
}

if (!$file_db_to_use)
{	
	GoBackToFormWithError("no db selected");
	exit;
}

if ($edited)
{
	if (!$editquery)
	{	GoBackToFormWithError("no edit commands");
		exit;
	}
}

$rawpath = $thispath;
if (!$make_bmp_tns)
{	$bmp_library_installed="no";
}


$processed_path = ProcessRawFilepath($rawpath); //in lib-files.php

echo "Processed path: $processed_path<p><hr><p>";

//04:48 05/11/2011.  ok, i guess around here is where we need to convert
//it to Windows format...

$disknick_amongst_aliases=array_key_exists($disknick, $disk_aliases);

if (!$disknick_amongst_aliases)
{
	DisplayWithError($disknick);
	GoBackToFormWithError("disknick not amongst disk aliases");
	exit;
}

$disk_alias_list=$disk_aliases[$disknick];
//PrintArr($disk_alias_list);
	//07:13 05/12/2011.  Only need to do this scan once... if it's a
	//directory import, all of the files within the dir will have the same
	//Windows disk letter.
//	PrintArr($disk_alias_list);

if ($platform_mode == "Windows")
{	$colonpos=strpos($processed_path, ":");
	$this_here_drive_letter=substr($processed_path, 0, $colonpos);
	//echo "Thisheredrievletter: $this_here_drive_letter ";
	foreach ($disk_alias_list as $windows_disk => $linux_mount_point)
	{
		if ($this_here_drive_letter==$windows_disk)
		{	//echo "Found this_here_drive_letter in disk_aliases";
			$found_paths_drive_letter_in_disk_aliases=true;
		}
	}
	if (!$found_paths_drive_letter_in_disk_aliases)
	{	GoBackToFormWithError("path's drive letter not assoc with disknick");
	}
}
else if ($platform_mode == "Linux")
{	
	foreach ($disk_alias_list as $windows_disk => $linux_mount_point)
	{
		$linux_mount_point_without_last_slash=rtrim($linux_mount_point, "/");
		//07:17 05/12/2011.  We just have to see if the path begins with 
		//any of the $linux_mount_points in $disk_aliases.
		if	( 
				(	strpos($processed_path, $linux_mount_point) 
				) === 0
				||
				(	$processed_path == $linux_mount_point_without_last_slash 
				) 
				
				
				//(	$processed_path == ( rtrim($linux_mount_point, "/") ) 
				//)
			)
				
				//	strpos($processed_path, rtrim($linux_mount_point, "/") ) === 0
		{
			$the_paths_windows_drive_letter=$windows_disk;
			$the_paths_linux_mount_point=$linux_mount_point;
			$string_length_of_the_paths_linux_mount_point=strlen($the_paths_linux_mount_point);
			break;
		}
	}
	//echo "Argh $the_paths_windows_drive_letter  | $the_paths_linux_mount_point ";
	
	//10:47 05/12/2011.  Must add more error messages here... 08:51 05/13/2011.  i think it's already covered...
	
	if (!$the_paths_windows_drive_letter)
	{	//echo "Eek, error";

		if (!$the_paths_linux_mount_point)
		{	DisplayWithError($disknick);
			GoBackToFormWithError("found disknick but no mt point found");
			exit;
		}
		else
		{
//		GoBackToFormWithError("missing windows drive letter in disk aliases");
			GoBackToFormWithError("found mt point but missing windows drive letter in disk aliases");
			exit;
		}
	}
	
	//echo "<p>Strlen: $string_length_of_the_paths_linux_mount_point ";
	
//echo "Processed path: $processed_path"; 

	//if ($processed_path == ( rtrim($the_paths_linux_mount_point, "/")) )
	if (!$linux_mount_point_without_last_slash)
	{
		if ( strpos($processed_path, "/mnt") ===0)
		{	GoBackToFormWithError("cant import dirs under mnt when linux disk path is only /");
			exit;
		}
	}
	if ($processed_path == $linux_mount_point_without_last_slash)
	{	#echo "WOOF";
		$windows_format_processed_path = "";
		$the_paths_parentdirs="";
		$the_paths_filename="";
		//$the_paths_filename="$the_paths_windows_drive_letter:";
		$the_paths_ext="";
		$added_root_of_linux_mountpoint=true;
		$the_path_without_linux_mount_point="";
		
	}
	else	
	{	#echo "ARGH";
		$the_path_without_linux_mount_point=substr($processed_path, $string_length_of_the_paths_linux_mount_point);
		
		//$the_paths_windows_format_parentdirs=substr($processed_path, $string_length_of_the_paths_linux_mount_point);
		
	//	$windows_format_processed_path=substr($processed_path, $string_length_of_the_paths_linux_mount_point);
		//08:35 05/12/2011. Would've done str_replace, but, I was worried
		//that in rare cases, the linux mount point text might be duplicated
		//later on in the path, and I couldn't figure out a way to limit
		//str_replace to just replacing the first match.
		
//		$windows_format_processed_path=str_replace( 	$the_paths_linux_mount_point, "", $processed_path);
		//$windows_format_processed_path=substr_replace($processed_path,  	$the_paths_linux_mount_point, "", $processed_path);
		


	//	echo "<br>Windows format processed path: $windows_format_processed_path <br>";
	}
	
	$windows_format_processed_path = $the_paths_windows_drive_letter . ":/" .$the_path_without_linux_mount_point;
//echo "<br>Windows format processed path: $windows_format_processed_path <br>";
//	echo "Disknick: $disknick $windows_format_processed_path";

	//echo "Path w/o mount point: $the_path_without_linux_mount_point <br>";
//	$first_slash_pos=LocateStringIn($the_path_without_linux_mount_point, "/");
	//echo "First slash pos: $first_slash_pos <br>";
	$last_slash_pos=strrpos($the_path_without_linux_mount_point, "/");
	
	if ($last_slash_pos!==false)
	{	$the_paths_parentdirs = substr($the_path_without_linux_mount_point, 0, $last_slash_pos);
	}
	else
	{	$the_paths_parentdirs="";
	}
	
/*	if ($first_slash_pos!==false)
	{	$the_paths_parentdirs = substr($the_path_without_linux_mount_point, 0, $first_slash_pos);
	}
	else
	{	$the_paths_parentdirs="";
	}
	*/
	
}


$native_format_processed_path=$processed_path;
//echo "<p><hr>native_format_processed_path: '$native_format_processed_path' <p>";
//$native_format_processed_path .= "/";
//$native_format_processed_path = "/" . $native_format_processed_path;

if (!file_exists($native_format_processed_path))
{	//echo "$native_format_processed_path OK we're in here";

	GoBackToFormWithError("nonexistent fileordir");
	exit;
}

$handle=ConnectToDb($file_db_to_use, "dont die");

if ($handle=="mysql_pconnect error" || $handle=="mysql_select_db error")
{	DisplayWithError(mysql_error(), 2);
	
	if ($handle=="mysql_pconnect error")
	{	
		GoBackToFormWithError("mysql_pconnect error", $extra_getvars);
		//echo mysql_error();
		exit;
	}
	else if ($handle=="mysql_select_db error")
	{	$uc_db=ucwords($radiobox_selected_idea_db);
		DisplayWithError($uc_db, 3);
		GoBackToFormWithError("mysql_select_db error", $extra_getvars);
		//echo mysql_error();
		exit;
	}
}

if ($edited)
{
	require ("lib-mass_editor.php");
	require ("lib-search.php");
	
	$editquery_part2=ParseEditQuery($editquery);
	//$editquery_part2=substr($editquery_part2, 2);
	$getvareditquery=str_replace("\r\n", ";;", $editquery); //12:50 PM, 3/17/2011.  ereg_replace removed
	
	if (!$editquery_part2 && !$changed_tagtypes && !$move_actual_files && !$locupdatecommand && !$making_delete_queries && !$making_tns)
	{	GoBackToFormWithError("no edit query");
		exit;
	}
	if ($move_actual_files || $locupdatecommand)
	{	GoBackToFormWithError("no file moves allowed in adder");
		exit;
	}
	if ($making_delete_queries )
	{	GoBackToFormWithError("not outputting delete queries");
		exit;
	}
	if ($making_tns)
	{	GoBackToFormWithError("no need for maketn command");
		exit;
	}
}

echo "<html><head><title>ABDesktop File Adder</title>
<link rel=stylesheet href=\"css/f.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style></head><body><center>";

AllOrganizerNavLinks();

echo "<h1>ABDesktop File Adder</h1>
<p>";
PrintDBHeader("file");
echo "<p><br><big>$native_format_processed_path";
//08:40 05/12/2011. In Linux, should test if it's a file or dir.  if dir, 
//put a slash on the end.  could do that in windows too, actually.
echo "</big>
<p>";


//Regardless of whether it's a directory or a file, we first want to see if it already exists in the db.

GetPathinfo($native_format_processed_path);

if ($platform_mode == "Linux")
{
	$disk=$the_paths_windows_drive_letter;
	$parentdirs=$the_paths_parentdirs;
	if ($added_root_of_linux_mountpoint)
	{
		$filename=$the_paths_filename;
		$ext=$the_paths_ext;
	}
	#echo "Parentdirs:::: '$parentdirs' ";
//	exit;
	//$parentdirs=$the_paths_windows_format_parentdirs;
}
else if ($platform_mode == "Windows")
{	#echo "BARK";
	if (!$parentdirs && strpos($filename, ":")!==false )
	{	echo "win filename: $filename <hr> $parentdirs ";
		$filename="";
	}
}

CleanAndEncloseOrIsNullPathinfo();

$cleandisknick=$disknick;
CleanInput($cleandisknick);

$cleandisknick=EncloseOrIsNull("disknick", $cleandisknick, "'");

if ($itemtype=="File")
{
	$query_to_issue = "SELECT file_id FROM fileinfo WHERE ( $cleandisk AND $cleanparentdirs AND $cleanfilename AND $cleandisknick AND $cleanext AND itemtype='$itemtype')";
}
else
{	
	$query_to_issue = "SELECT file_id FROM fileinfo WHERE ( $cleandisk AND $cleanparentdirs AND $cleanfilename AND $cleandisknick AND itemtype='$itemtype' )";
}
echo "$query_to_issue<p>";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

//Just some setting up before we act on the knowledge we just gained...

$Insert_Filedetails_querystart="INSERT INTO
	fileinfo (filesize, extcat, itemtype, disknick, disk, parentdirs, filename, ext, filelm, filecr, paired, pairedname, repository, contentsimported, privacy, licensetype, whenadded, lastread, importdate) VALUES ";
	
$Insert_ImageDetails_querystart = "INSERT INTO
	imageinfo (file_id, width, height, area, aspectratio, reverse_aspectratio, wideortall, showthumbnail, hasthumbnail) VALUES ";

	$repository="y";   //placed in repository by default.
	$privacylevel=6;  //default privacy level: 5, undecided.
	$licensetype=5;  //default license type 4, unknown.
	$whenadded="now()";
	$lastread="now()";
	$rawitemtype=$itemtype;
	CleanInput($disknick);
	$disknick=EncloseOrNull($disknick, "'");


if (mysql_num_rows($query_result) < 1)
	//Then, the item the user put in doesn't exist in the database yet, so we will insert all its details.
{
//	echo "Added to database!";
	
	GetFileDetails($native_format_processed_path); //in lib-files.php
	
	
	GetFileSizeAndDates($native_format_processed_path, $should_add_12_hours_to_filelm_and_filecr_when_adding_files);
	EncloseOrNullFileSizeAndDates();

	$rawextcat=$extcat;
	$rawext=$ext;
	
	CleanFileDetails();
	EncloseOrNullFileDetails();
	
	if ($rawitemtype=="Dir" && $add_dirfiles=="y")
	{	$contentsimported="n";
		$importdate="null"; //for now; just in case it gets stopped in the middle.
	}
	else
	{	$contentsimported="n";
	}
	EncloseOrNullOtherDetails();
	echo "Adding to database...";
		
	$query_to_issue = $Insert_Filedetails_querystart . " ($filesize, $extcat, $itemtype, $disknick, $disk, $parentdirs, $filename, $ext, $filelm, $filecr, $paired, $pairedname, $repository, $contentsimported, $privacylevel, $licensetype, $whenadded, $lastread, $importdate) ";
	
	echo "<p>$query_to_issue";
	
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	echo "<p>Added to database!<p>";
	$mainpath_id=mysql_insert_id();
	$runeditonmainpath=true;
	
		//If we're adding a single file, we run the edit query now.

	if ($edited && $runeditonmainpath && !$add_dirfiles) //&& $rawitemtype=="File"
	{
		$result=ExecuteMassEdit("adder", $mainpath_id, 1);
		
		$getvareditquery=str_replace("\n", ";;", $editquery); //12:50 PM, 3/17/2011.  ereg_replace removed
		DisplayWithNotif($getvareditquery);
	
		if ($notif=="edit exec")
		{	EchoNotif("Your edit query, <b>$_SESSION[notifdisp]</b>, has been executed.<p><br>Queries issued: <p>$queries_issued");
		}
	}
	
	
	if ($rawextcat=="Image")
	{	
		$lowercaserawext=strtolower($rawext);
		if ($bmp_library_installed && $lowercaserawext=="bmp")
		{	require("../lib-bmp.php");
			$bmp_lib_included=true;
		}
		if ($make_tns=="y")
		{	
			MakeThumbnail($native_format_processed_path, $rawext, $mainpath_id);
		}
		else
		{	$showthumbnail="y";
			$hasthumbnail="n";
		}
		
		//echo "Showthumbnail: $showthumbnail ";
		EncloseOrNullImageDetails();
		//echo "Showthumbnail: $showthumbnail <p>";
		
		$query_to_issue = $Insert_ImageDetails_querystart . " ($mainpath_id, $imagewidth, $imageheight, $imagearea, $aspectratio, $reverse_aspectratio, $wideortall, $showthumbnail, $hasthumbnail) ";
		echo "<p>$query_to_issue";
		
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	}
}
else   // 04:49 05/11/2011.  OK, the item does exist in the DB already.
{	
	//$argh = mysql_fetch_array($query_result);
	//$vartoget=array("file_id");
	//PrintQueryResultGrid($query_result, $vartoget);

	//$mainpath_id=$argh['file_id'];
	$mainpath_id=mysql_result($query_result,0,'file_id');
	echo "Already in database, so not re-added. ";
	echo "Mainpath id: $mainpath_id<p><br>";
}

	
//if importing contents now, though, we do want to update the existing entry with a new import date,
//later, though, after we get the file size of the entire directory.
if ($rawitemtype=="Dir" && $add_dirfiles=="y")
{
	$update_orig_path_size_and_impdate=true;
}

//OK, if the user imported only a single file or directory, then, we're actually done already.

if ($rawitemtype=="File")
{	echo "<p><br>Done.";
	exit;
}

//But, if the user imported a dir and wanted the contents added too, then, we now have to
//do that.  We next grab all the files in that dir and see which ones are
//already in the database, and add any new ones.

$dots_to_exclude=array(".", "..");


if ($rawitemtype=="Dir" && ( $add_dirfiles || $import_dirs_recursively ) )
{
	$count_of_dirs_to_process=1;
	
	$dirs_to_process=array();
	
	array_push($dirs_to_process, $native_format_processed_path);
	
	#$path_to_process=$native_format_processed_path;
	
	while ( $count_of_dirs_to_process > 0 )
	{	
		$imagespresent=false;
		$array_newfiles=array();
		$array_oldfiles=array();
		$array_newimages=array();
		
		echo "<p><h3>Start of while loop - count_of_dirs_to_process - $count_of_dirs_to_process </h3>";
		
	#	echo "native_format_processed_path - $native_format_processed_path - ";
		$path_to_process=array_shift($dirs_to_process);
		
		echo "path_to_process after doing shift - $path_to_process - ";
		#GetPathinfo($native_format_processed_path);
		
		GetPathinfo($path_to_process);
		echo "Parentdirs zarg: $parentdirs";
		if ($platform_mode == "Linux")
		{
			$disk=$the_paths_windows_drive_letter;
			if ($added_root_of_linux_mountpoint)
			{
				$parentdirs=$the_paths_parentdirs;
			
				echo "Filename: $filename ";
				$filename=$the_paths_filename;
			}
			else
			{	//$parentdirs=
			}
		//	exit;
			//$parentdirs=$the_paths_windows_format_parentdirs;
		}

		CleanPathinfo();
		
		$path_to_process_parentdirs=$cleanparentdirs;
		$path_to_process_dirname=$cleanfilename;
		
		echo "QUACK  parentdirs $parentdirs  filename: $cleanfilename ";
		if ($cleanparentdirs || $cleanparentdirs==="0")
		{	$fileparentdirs = "parentdirs = '" . $cleanparentdirs . "/$cleanfilename'";
			echo "OINK";
		}
		else if(!$cleanparentdirs)
		{	if ($platform_mode=="Windows")
			{
				if (strpos($cleanfilename, ":")!==false )
				{	$fileparentdirs="isnull(parentdirs) and filename is not null";
				}
				else
				{
					if ($cleanfilename)
					{
						$fileparentdirs = "parentdirs = '$cleanfilename'";
					}
					else
					{	$fileparentdirs = "isnull(parentdirs) and filename is not null";
					}
				}
			}
			else if ($platform_mode=="Linux")
			{	if ($cleanfilename)
				{	$fileparentdirs = "parentdirs = '$cleanfilename'";
				}
				else
				{	$fileparentdirs = "isnull(parentdirs) and filename is not null";
				}
			}
		}
	//echo "ARGH $fileparentdirs ";
		$query_to_issue = "SELECT filename, ext, filesize, itemtype, paired, unimportable FROM fileinfo WHERE $cleandisknick AND disk='$cleandisk' AND $fileparentdirs";
		
		echo "<p>Results of trying to add contents of the above path:<p>";
		
		echo "<p>$query_to_issue";

		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

		//	$dirfiles=scandir($native_format_processed_path);
		#echo "native_format_processed_path again: $native_format_processed_path - ";
		#echo "path_to_process again: $path_to_process - ";
		
		$dirhandle=opendir($path_to_process);
		$zz=0;
		$dirfiles=array();
		//The reason we go to all this trouble instead of just using scandir
		//is because scandir does an automatic sort on the array which 
		//actually incorrectly puts the items _out_ of alphabetical order.
		//This way puts them in the correct order.
		while (false !== ( $thisfile = readdir($dirhandle) ) )
		{	$dirfiles[$zz]=$thisfile;
			$zz++;
		}
		PrintArr($dirfiles, "Dirfiles array");
		closedir($dirhandle);
		natcasesort($dirfiles);
		
		

		$dirfiles = array_diff($dirfiles, $dots_to_exclude);

		$dirfiles = array_merge($dirfiles);

		$num_of_actual_files=count($dirfiles);
		$quantity=$num_of_actual_files;

		$x=0;
		$folder_total_filesize=0;

		if (mysql_num_rows($query_result) > 0)
		{	//If any files were already in the database, we retrieve their details.
			while ($fileinfo = mysql_fetch_array($query_result))
			{	
				#echo "<p>in this while loop";
				
				$thisfn=$fileinfo[filename];
				$thisext=$fileinfo[ext];

				$thisfilesize=$fileinfo[filesize];
				
				$thisitemtype=$fileinfo[itemtype];
				
				$thispaired=$fileinfo[paired];
				$thisunimportable=$fileinfo[unimportable];
				
				$folder_total_filesize += $thisfilesize;
				
				
				if ($thisfn && $thisext)
				{	
					$array_files_in_db[$x]="$thisfn.$thisext";
				}
				else if ($thisfn && !$thisext)
				{	
					if ($thisext!=null)
					{	
						$array_files_in_db[$x]="$thisfn.0";
					}
					else
					{	$array_files_in_db[$x]="$thisfn";
					}
				}
				else if (!$thisfn && $thisext)
				{	
					if ($thisfn!=null)
					{	
						$array_files_in_db[$x]="0.$thisext";
					}
					else
					{	$array_files_in_db[$x]=".$thisext";
					}
				}
				else if (!$thisfn && !$thisext)
				{	
					if ($thisfn!=null && $thisext!=null)
					{	$array_files_in_db[$x]="0.0";
					}
					else if ($thisfn!=null && $thisext==null)
					{	$array_files_in_db[$x]="0";
					}
					else if ($thisfn==null && $thisext!=null)
					{	$array_files_in_db[$x]=".0";
					}
				}
				
				
				if ($thisitemtype=="Dir" && $thispaired=="n" && $thisunimportable=="n")
				{
					#echo "YAY";
					$full_path_to_dir_to_process=$path_to_process . "/" . $array_files_in_db[$x];
					
					if ( $import_dirs_recursively)
					{
						array_push($dirs_to_process, $full_path_to_dir_to_process);
					}
					#$array_of_child_dirs_already_in_db[$x]=$array_files_in_db[$x];
				}
				
				$x++;
			}
			
			
			echo "<h4>Current path to process: $path_to_process</h4>";
			
			PrintArr($dirs_to_process, "Dirs to process");
			//Then we figure out which of the dirfiles are already in the database.
		//	if (is_array($array_files_in_db) )
		//	{
			$array_oldfiles = array_intersect($dirfiles, $array_files_in_db);

			//This bit here is just to make the index continuous instead of having gaps:
			$array_oldfiles =array_merge($array_oldfiles);

			//Then we find out which dirfiles aren't in the database yet and need to be added.
			$array_newfiles = array_diff($dirfiles, $array_files_in_db);

			$array_newfiles = array_merge($array_newfiles);
			
			#foreach ($array_newfiles as $newfile)
			#{
				
			#}
	//PrintArr($dirfiles);
			//Only the new files need to be inserted into the fileinfo table.  The old
			//files' entries can be left alone.  We're not even going to bother updating
			//the old files' dates or sizes, or anything else of the old files.
		}
		else	//If there are no rows, then there are no existing records, so
				//all the files in the directory are new to the database.
		{
			$array_newfiles=$dirfiles;
		}

		$x=0;

	//OK, now we handle the addition of the new files.

		$numofnewfiles=count( $array_newfiles );
		$numofoldfiles=count( $array_oldfiles );

//		echo "<pre>";
		PrintArr($array_newfiles, "$numofnewfiles New Files:");
		PrintArr($array_oldfiles, "$numofoldfiles files already in DB:");
		
		$query_to_issue = $Insert_Filedetails_querystart;
		
		if ($numofnewfiles>0)
		{
			$y=0;

			while ($x<$numofnewfiles)
			{	$thisfile=$array_newfiles[$x];

				if ($thisfile == ".")
				{	echo "dot found this makes no sense";
				}
				if ($thisfile == "..")
				{	echo "dots found WHY???????";
				}
			
				$thispath=$path_to_process . "/" . $thisfile;
				$thispath=StripExtraSlashes($thispath);
				$thiscleanpath=$thispath;
				CleanInput($thiscleanpath);
				
				UnsetFileDetails();
				GetPathinfo($thispath);
				
				if ($platform_mode == "Linux")
				{
					$disk=$the_paths_windows_drive_letter;
					$parentdirs=$the_path_without_linux_mount_point;
				#	echo "<hr>Thepath w/o linux mtpoint $the_path_without_linux_mount_point ---<hr>";
				}
				
				GetFileDetails($thispath); //in lib-files.php
				GetFileSizeAndDates($thispath, $should_add_12_hours_to_filelm_and_filecr_when_adding_files);
				
				$folder_total_filesize += $filesize;
				
				EncloseOrNullFileSizeAndDates();
			
				$rawitemtype=$itemtype;
				
				if ($itemtype=="Dir" && $import_dirs_recursively )
				{	
					#echo "<h2>PUSHING</h2>";				
					array_push($dirs_to_process, $thispath);
					
				}
				$rawextcat=$extcat;
				$rawext=$ext;
			
				if ($rawextcat=="Image" || $rawextcat=="Icon")
				{	$array_newimages[$y]=$thisfile;
					if ($rawextcat=="Icon")
					{	$icons_present=true;
					}
					$imagespresent=true;
					if ($bmp_library_installed==true && !$bmp_lib_included && !$bmps_present)
					{	$lowercaserawext=strtolower($rawext);
						if ($lowercaserawext=="bmp")
						{	$bmps_present=true;
						}
					}
					$y++;
				}
			
				CleanFileDetails();
				EncloseOrNullFileDetails();
		
				$contentsimported="n";
				$importdate="";
				$repository="y";
				EncloseOrNullOtherDetails();

				
				$query_to_issue .= " ($filesize, $extcat, $itemtype,  $disknick, $disk, $parentdirs, $filename, $ext, $filelm, $filecr, $paired, $pairedname, $repository, $contentsimported, $privacylevel, $licensetype, $whenadded, $lastread, $importdate),\n\n";

				$x++;
			}
		
			$query_to_issue=substr($query_to_issue, 0, -3);
			echo "<p><pre>$query_to_issue</pre><p>";
			
			$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
			$insertedfileid=mysql_insert_id();

			//now, we want to update the original file path with a new import date,
			//set contentsimported to 'y', and add the file size - the total memory taken up 
			//by all the files in the folder.

			if ($update_orig_path_size_and_impdate==true)
			{
				$dirquery="</b><p><br>Updating import date and dir file size:</b><p>";
				#$query_to_issue="update fileinfo set contentsimported='y', importdate=now(), filesize=$folder_total_filesize, quantity=$quantity where file_id=$mainpath_id limit 1";
				$query_to_issue="update fileinfo set contentsimported='y', importdate=now(), filesize=$folder_total_filesize, quantity=$quantity where $cleandisknick AND disk='$cleandisk' AND parentdirs='$path_to_process_parentdirs' AND filename='$path_to_process_dirname' limit 1";
				
				$dirquery.="<p>$query_to_issue ";
				echo $dirquery;
				
				$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
			}

			//OK, now we execute the edit query before doing the image stuff.  The image
			//stuff is the stuff most likely to fail, so we might as well get the edit query executed
			//before the script possibly gets halted.

			if ($edited)
			{
				if ($runeditonmainpath)
				{	#$result=ExecuteMassEdit("adder", $mainpath_id, $numofnewfiles+1);
				}
				else
				{
					$result=ExecuteMassEdit("adder", $insertedfileid, $numofnewfiles);
				}
				
				DisplayWithNotif($getvareditquery);
				echo "<p>";
				if ($notif=="edit exec")
				{	EchoNotif("Your edit query, <b>$_SESSION[notifdisp]</b>, has been executed.<br># affected: $_SESSION[notifdisp2]</b><br>$_SESSION[notifdisp3]<p><br>Queries issued (likely incomplete list):<p>$queries_issued");
				}
				if ($warning=="page and allresults commands not needed")
				{	EchoWarn("Warning: In the file adder, the \"page\" and \"allresults\" commands are unnecessary, since edits automatically affect all files added.");
				}
			}

		
			//Next, the image stuff.	
			if ($imagespresent)
			{
				if ($bmp_library_installed==true && !$bmp_lib_included && $bmps_present==true)
				{	require("../lib-bmp.php");
				}
				if ($icons_present)
				{	//require("../lib-class.ico.php");
				}
				$x=0;
				$query_to_issue=$Insert_ImageDetails_querystart;
				
				$allimageids=array();
				$allimagexts=array();
				$numofnewimages=count( $array_newimages );
				PrintArr($array_newimages, "$numofnewimages New Images:");
				while ($x<$numofnewimages)
				{
					
					
					$key=array_search($array_newimages[$x], $array_newfiles);
					
					echo "Key: $key ";
					
					PrintArr($array_newimages[$x], "array newimages x");
					PrintArr($array_newfiles, "array newfiles");
					
					$thisfile=$array_newimages[$x];
					$thisfileid=$insertedfileid+$key;
					
					echo "This fileid: $thisfileid ";
					
					$allimageids[$x]=$thisfileid;
					
					$thispath=$path_to_process . "/" . $thisfile;
					$thispath=StripExtraSlashes($thispath);
					$thiscleanpath=$thispath;
					CleanInput($thiscleanpath);
					
					UnsetFileDetails();
					UnsetImageDetails();
					
					GetPathinfo($thispath);
					
					if ($platform_mode == "Linux")
					{
						$disk=$the_paths_windows_drive_letter;
						$parentdirs=$the_path_without_linux_mount_point;
					}
					
					
					
					GetFileDetails($thispath); //in lib-files.php
					$rawext=$ext;
					$allimagexts[$x]=$rawext;
					$allshowtn[$x]=$showthumbnail;
						
					if ($make_tns=="y")
					{
						$showthumbnail="y";
						$hasthumbnail="n";
						//MakeThumbnail($thispath, $rawext, $thisfileid);
						//Used to make them here but it's better to do them later.
					}
					else
					{	$showthumbnail="y";
						$hasthumbnail="n";
					}
					EncloseOrNullImageDetails();
				
					$query_to_issue .= " ($thisfileid, $imagewidth, $imageheight, $imagearea, $aspectratio, $reverse_aspectratio, $wideortall, $showthumbnail, $hasthumbnail),\n\n";
				//	echo "<p>echo $query_to_issue";
					$x++;
				}
				$query_to_issue=substr($query_to_issue, 0, -3);
				#echo "<p><b>Image query:</b><p>	$query_to_issue";
				$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
			
				
				//It's way safer to do the thumbnail stuff last after
				//the imageinfo query has been sent already.
				
				if ($make_tns=="y" || ($make_tns=="n" && $make_ico_tns=="y") )
				{
					$x=0;
					foreach ($allimageids as $thisfileid)
					{
						$thisfile=$array_newimages[$x];
						$thispath=$path_to_process . "/" . $thisfile;
						$thispath=StripExtraSlashes($thispath);
						$rawext=$allimagexts[$x];
						$rawshowtn=$allshowtn[$x];
					#	echo " Image file: $thisfile ";
						if ($rawshowtn=="y")
						{
							if ($rawext!="ico")
							{	if ($make_tns=="y")
								{	$madetn=MakeThumbnail($thispath, $rawext, $thisfileid);
								}
							}
							else
							{	if ($make_ico_tns=="y")
								{	$icon = new Ico($thispath);
								
									list($width, $height, $index_of_largest_icon) = GetLargestIconDetails($icon);
									$icon_imgdata=$icon->GetIcon($index_of_largest_icon);
									if ($icon_imgdata)
									{#	echo "YES icon_imgdata $icon_imgdata";
										$madetn=MakeThumbnail(false, false, $thisfileid, false, $icon_imgdata, true, false);
									}
								}
							//	echo "Imgdata: $icon_imgdata";
								//Insert destroy object query here?  for icon_imgdata or $icon?
								
							}
						}
						$lowercasext=strtolower($rawext);
					//	if ($lowercasext!="bmp" || ($lowercasext=="bmp" && $make_bmp_tns)
						//{
						if ($madetn)
						{	//05:03 05/11/2011. would probably be better to pile up
							//a bunch of IDs and update all in one query...
							$query_to_issue="UPDATE imageinfo SET hasthumbnail='y' WHERE file_id=$thisfileid LIMIT 1";
							$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
						}
						$x++;
					}
				}
				echo $dirquery;
			}
		}
		//now, we want to update the original file path with a new import date,
		//set contentsimported to 'y', and add the file size - the total memory taken up 
		//by all the files in the folder.
		else
		{
			if ($update_orig_path_size_and_impdate==true)
			{
				$dirquery="</b><p><br>Updating import date and dir file size:</b><p>";
			#	$query_to_issue="update fileinfo set contentsimported='y', importdate=now(), filesize=$folder_total_filesize, quantity=$quantity where file_id=$mainpath_id limit 1";
				$query_to_issue="update fileinfo set contentsimported='y', importdate=now(), filesize=$folder_total_filesize, quantity=$quantity where $cleandisknick AND disk='$cleandisk' AND parentdirs='$path_to_process_parentdirs' AND filename='$path_to_process_dirname' limit 1";
				
				$dirquery.="<p>$query_to_issue ";
				echo $dirquery;
				
				$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
			}
		}
	
	$count_of_dirs_to_process=count($dirs_to_process);
	#echo "<h4> Count of dirs, sigh $count_of_dirs_to_process";
	#PrintArr($dirs_to_process, "Final dirstoprocess");	
		
	} 	//End of while loop
	
}

echo "</pre></pre>";
AllOrganizerNavLinks();
