<?php
$current_organizer="file";
require ("../../lib-abdesk.php");

CheckCookie();

$errorvarname="output_folder_structure_error";

session_start();


require ("../../lib-files.php");

function GoBackToFormWithError($err)
{	global $errorvarname, $file_db_to_use;
	$_SESSION[$errorvarname]=$err;
	header("Location: file_adder_form.php?db=$file_db_to_use");
	exit;
}

if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
	ini_set("max_execution_time", "$phpmaxexec");
	//echo ini_get("memory_limit");
}


	$add=$_POST[add];
	$edited=$_POST[edited];
	$should_include_files=$_POST[should_include_files];

if (!$add && !$edited)	//Then it was a GET and not a POST
{	
	$db=$_GET[db];
	if ($db)
	{
		$file_db_to_use=$db;
	}
}
else 	// It was a POST after all
{
	//$varstoget_fromform=array("thispath", "add_dirfiles", "make_tns", "make_ico_tns", "make_bmp_tns", "editquery", "disknick", "radiobox_selected_file_db");
	$varstoget_fromform=array("radiobox_selected_file_db");

	foreach ($varstoget_fromform as $varname)
		{
			${$varname}=$_POST[$varname];
//In case the user gets sent back to the form, this makes it so their original
//input is preserved:
			$_SESSION[$varname]=$_POST[$varname];
		}
	$file_db_to_use=$radiobox_selected_file_db;
}

if (!$file_db_to_use)
{	
	GoBackToFormWithError("no db selected");
	exit;
}


require ("lib-output_folder_structure.php");

$handle=ConnectToDb($file_db_to_use, "dont die");

//list($array_of_unpaired_folder_paths_from_db, $array_of_unpaired_folder_paths_from_db_with_disks, $array_of_disknicks_of_unpaired_folder_paths_from_db, $num_of_paths)=Get_All_Disknicks_and_Paths_from_DB($handle);


$paths_and_disknicks=Get_All_Disknicks_and_Paths_from_DB_and_Make_List_of_Paths_and_Disknicks($handle, $should_include_files );


echo "<html><head><title>ABDesktop $file_db_to_use Folder Structure - </title>
<link rel=stylesheet href=\"../css/f.css\" type=\"text/css\">
<style type=\"text/css\">

</style></head><body><center>";

AllOrganizerNavLinks();

echo "<h1>ABDesktop File DB - Output Folder Structure</h1>
<p>";
PrintDBHeader("file");

$count_of_paths=count($paths_and_disknicks);

echo "<p>Num of paths: $count_of_paths";

/*PrintArr($array_of_unpaired_folder_paths_from_db);
PrintArr($array_of_unpaired_folder_paths_from_db_with_disks);
PrintArr($array_of_disknicks_of_unpaired_folder_paths_from_db);
*/

echo "</center>";


$prev_count_of_slashes_in_path=0;

//PrintArr($disk_aliases);

function Echo_Hyperlink_for_Disknick($disknick, $label, $path="")
{	global $disk_aliases;

	//echo "disknick: $disknick ";
	$hyperlink_uri = "file://localhost/" . key($disk_aliases[$disknick]) . ":/" . $path;
	
	echo "<a name=\"$path\"></a><a href='$hyperlink_uri'>$label</a>&nbsp;";
	echo Get_File_Lister_Browse_Folder_Link($disknick, $path, true);
	echo " &nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp; ";
	
}
foreach($paths_and_disknicks as $path => $disknicks)
{
	//echo "<li>";
	if (!$path)
	{	// 11:41:20 3/3/2014. Then, root level of a disk.
		//echo "EEK";
		echo "<center>";
		//Disknicks present in DB:<p>";
		foreach ($disknicks as $disknick)
		{	echo "Disknick: $disknick ";
			//$hyperlink_label=key($disk_aliases[$disknick]);
			//$hyperlink_label = "$disknick &nbsp; " . key($disk_aliases[$disknick]) . ":/";
			
			Echo_Hyperlink_for_Disknick($disknick, "$disknick&nbsp;&nbsp;&nbsp;" . key($disk_aliases[$disknick]) . ":/" );
			
			//$hyperlink_label );
			
		//	$hyperlink_uri = "file://localhost/" . key($disk_aliases[$disknick]) . ":/";
		//	$hyperlink_label=current($disk_aliases[$disknick]);
			
		}
		echo "</center>";
		echo "<ul>";
		continue;
	}
	$count_of_slashes_in_path = substr_count($path, "/");
	
	//echo " count: $count_of_slashes_in_path $prev_count_of_slashes_in_path $path ";
	
	if ($count_of_slashes_in_path>=$prev_count_of_slashes_in_path)
	{
		$num_of_uls_to_make=$count_of_slashes_in_path-$prev_count_of_slashes_in_path;
		echo str_repeat("<ul>", $num_of_uls_to_make);
			
		
	}
	else if ($count_of_slashes_in_path<$prev_count_of_slashes_in_path)
	{	$num_of_uls_to_close=$prev_count_of_slashes_in_path-$count_of_slashes_in_path;
		echo str_repeat("</ul>", $num_of_uls_to_close);
	
	}
	

	echo "<li>";
	
	
	
	if ($count_of_slashes_in_path<$prev_count_of_slashes_in_path )
	{	$slashes_less_than_prev_count = $prev_count_of_slashes_in_path - $count_of_slashes_in_path;
		if ( $slashes_less_than_prev_count > 1)
		{	//$path;
			$string_to_print = Get_Path_with_Last_Folder_Highlighted($path);
			//$string_to_print = Get_Last_Folder_from_Path($path);
		}
		else
		{	$string_to_print = Get_Last_Folder_from_Path($path);
		#	$string_to_print="<b>$string_to_print</b>";
		}
	}
	if ($count_of_slashes_in_path>=$prev_count_of_slashes_in_path)
	{	
		$string_to_print = Get_Last_Folder_from_Path($path);
		
	}
	//echo "<table><tr><td>";
	echo $string_to_print;
	echo " &nbsp;&nbsp; ";
	
	
	foreach ($disknicks as $disknick)
	{
		Echo_Hyperlink_for_Disknick($disknick, $disknick, $path);
	}
	//echo "</table>";
	
	/*		$fragmentized_path=explode("/", $path);
	
		$hyperlink_label=end($fragmentized_path);
		
		echo "<li>"; 
		echo $hyperlink_label;*/
		
	
	$prev_count_of_slashes_in_path=$count_of_slashes_in_path;
}

$num_of_uls_to_close=$prev_count_of_slashes_in_path;
echo str_repeat("</ul>", $num_of_uls_to_close);
echo "</ul>";

function Get_Path_with_Last_Folder_Highlighted($path)
{
	$fragmentized_path=explode("/", $path);
	
	$last_folder=array_pop($fragmentized_path);
	
	$reglued_path=implode("/", $fragmentized_path);
	
	$reglued_path = "<big><b><code>" . $reglued_path . "/</code>" . "<br>$last_folder</b></big>";
	
	return $reglued_path;
	
}

function Get_Last_Folder_from_Path($path)
{
	$fragmentized_path=explode("/", $path);
	
	$last_folder=end($fragmentized_path);
	
	//$last_folder = "<b>" . $last_folder . "</b>";

	//echo "* func ";
	//	echo "<li>"; 
	//	echo $hyperlink_label;*/
//	return $path;
	return $last_folder;
}

echo "</ul>";


/*
echo "<table border>";

foreach($paths_and_disknicks as $path => $disknicks)
{
	echo "<tr><td>";
	$count_of_slashes_in_path = substr_count($path, "/");
	//echo $count_of_slashes_in_path;
	$tds_made=0;
	while ($tds_made<$count_of_slashes_in_path)
	{
		echo "<td>";
		$tds_made++;
	}
	$fragmentized_path=explode("/", $path);
	
	$hyperlink_label=end($fragmentized_path);
	
	echo $hyperlink_label;
}

echo "</table>";

*/

$repeat_count=$num_of_path_parts;
echo str_repeat("</ul>", $repeat_count);

echo "<center>";
AllOrganizerNavLinks();
?>