<?php
$microtime_at_start_of_lib_abdesk=GetMicrotime();



$abdesktop_version="2.0";


$autodetecting_platform=true;



if ($autodetecting_platform)
{
	$document_root=$_SERVER[DOCUMENT_ROOT];
	$platform_mode=IdentifyFilepathType($document_root);
}
else
{
	//If you set autodetecting_platform to false, you must
	//manually specify your platform here.

	//Currently, the only two valid values are: 
	//
	//Linux
	//Windows
	
	$platform_mode="Linux";
	//$platform_mode="Windows";		 //Formerly $filepath_mode
	//$platform_mode="Linux";
}



$webpath_of__web_server="http://localhost";	//Don't put a slash on the end

$custom_settings_folder_to_use = "custom";

#$custom_settings_folder_to_use = "abdesk-private";
$custom_settings_folder_to_use2 = $custom_settings_folder_to_use;

//$custom_settings_folder_to_use2 = "custom";

$abdesktop_folder_name="/abdesk";
	//Formerly $siteroot

$abdesktop_data_folder_name="/abdesk-data";
	//Formerly $datafol, I think
	
	
$webpath_of__abdesktop=$webpath_of__web_server . $abdesktop_folder_name; 
	//Formerly $mainsitepathweb.
	//Example: http://localhost/abdesk
	
	
$localpath_of__abdesktop=$_SERVER[DOCUMENT_ROOT] . $abdesktop_folder_name; 
	

$valid_platform_modes=array("Windows", "Linux");



if (!in_array($platform_mode, $valid_platform_modes) )
{
	echo "<html><head><title>Astroblahhh Desktop Warning: Invalid platform mode - $platform_mode</title>
	<link rel=stylesheet href=\"$webpath_of__abdesktop" . "/css/f.css\" type=\"text/css\"></head><body>";
	
	echo "<center><h1>Astroblahhh Desktop Warning:</h1>
	<p><big>Invalid platform mode:<p>
	$platform_mode
	<p>
	Please edit <b>lib-abdesk.php</b> to fix this.<p>
	<br>
	The platform modes that are available currently:<p>";
	
	foreach ($valid_platform_modes as $mode)
	{	echo "$mode<br>";
	}
	exit;
}



$width_of_db_list=6;

//***********Which organizers are useable

$url_organizer_enabled=true; 					//Formerly $linksdb_active
$idea_organizer_enabled=true;				 //Formerly $ideasdb_active
$file_organizer_enabled=true;					//Formerly $filesdb_active


//If true, the ConnectToDB() and ConnectAsRoot() functions can access 
//databases of the type specified in the variable name (URL DBs, idea DBs,
//or file DBs).
//
//If false, the ConnectToDB() and ConnectAsRoot() functions will refuse 
//to connect to those databases, basically disabling your ABDesktop 
//URL organizer, idea organizer, or file organizer.
//
//However, your databases will still be accessible through other 
//programs, like PhpMyAdmin, or by sending commands directly to 
//your MySQL or MariaDB server.



//**********Memory/execution time limit settings.
//
//Not used everywhere. 15:55 06/04/2011.  I assume.

$setphpdefaults=true;	//If set to false, these settings won't be used.
$phpmem="200M";
$phpmaxexec="600"; //240



require ("$localpath_of__abdesktop/files/not-in-abdesk-3_0/lib-not-in-abdesk-3_0.php");



//************************Default DBs to use

require ("$localpath_of__abdesktop/$custom_settings_folder_to_use/default_dbs_to_use.php");

/*
$url_db_to_use="abdesklinks";
$idea_db_to_use="abdeskideas";
$file_db_to_use="abdeskfiles";
*/


//*************Lists of all your DBs.

require ("$localpath_of__abdesktop/$custom_settings_folder_to_use/lists_of_all_your_dbs.php");

/*
$url_dbs=array("mylinks");  //Formerly links_dbs

$idea_dbs=array("myideas");

$file_dbs=array("myfiles");

*/

									//Stuff you need to customize

require ("$localpath_of__abdesktop/$custom_settings_folder_to_use2/passwords.php");


//Other stuff
$localip="127.0.0.1";

$allow_only_one_ip=true;
$neededip=$localip;



	//Formerly $mainsitepath
	//
	//Example, in Lucid Puppy 5.2/LHMP: 
	//
	//		/root/Web-Server/abdesk
	
	//Or, in Windows XP/XAMPP: 
	//
	//		C:\xampp\htdocs\abdesk
	//	(Verify later, paste in real address)

//	echo "Localpath: $localpath_of__abdesktop";


$localpath_of__abdesktop_main_css_folder=$localpath_of__abdesktop . "/css"; 
	//Formerly $abdeskcsspath
	//Example: /root/Web-Server/abdesk/css
	
	
$localpath_of__abdesktop_data_folder = 
	//Formerly $datapath
$_SERVER[DOCUMENT_ROOT] . $abdesktop_data_folder_name;	
	//Example: /root/Web-Server/abdesk-data

$webpath_of__abdesktop_data_folder=$webpath_of__web_server . $abdesktop_data_folder_name;
		//Example: http://localhost/abdesk-data

		
		
		
$localpath_of__abdesktop_data_css_folder =
//Formerly $maincsspath
	$_SERVER[DOCUMENT_ROOT] . $abdesktop_data_folder_name . "/css"; 
	//Example: /root/Web-Server/abdesk-data/css

	
$localpath_for_delete_queries=$localpath_of__abdesktop_data_folder . "/delete-queries";
$localpath_for_db_exports=$localpath_of__abdesktop_data_folder . "/db-exports";

	
$localpath_for_logfile=$localpath_of__abdesktop_data_folder . "/log.php";




if ($platform_mode=="Windows")
{
	$thumbnails_on_diff_disk_from_xampp=true;
	//$thumbnails_on_diff_disk_from_xampp=false;
	$thumbnail_location_apache_alias="/l";
	$thumbnail_disk="L";
}
else if ($platform_mode=="Linux")
{	$thumbnails_on_diff_disk_from_xampp=false;
}



//echo "Maincsspath: $localpath_of__abdesktop_data_css_folder  Abdeskcsspath: $localpath_of__abdesktop_main_css_folder ";



							//Stuff you might want to customize

date_default_timezone_set("America/New_York");
	//Time zone setting


	
	
	
	//Stuff you can probably leave alone
	
$abdesktop_path="$webpath_of__abdesktop/";
	//Used in the navigational links functions.  Only needs to
	//be changed if you change the "abdesk" folder's name to
	//something else.



//Mass editor settings
//Set these to true if you want the "allresults" edit command to work.

$idea_organizer__allows_allresults_mass_edit_command=true;
$idea_organizer__allows_commands_that_issue_delete_queries=true;



function SelectDb($thisdb, $handle)
{
	mysql_select_db("$thisdb",$handle) or die(mysql_error());
	return true;
}



function ConnectToDb($thisdb, $make_new_link=false, $dont_die=false)
{	
		global 
			$idea_organizer_enabled, $url_organizer_enabled, $file_organizer_enabled, 
			$idea_db_to_use, $file_db_to_use, $url_db_to_use, 
			$mysql_username, $mysql_password;

	if ( ($thisdb==$idea_db_to_use && $idea_organizer_enabled) || ($thisdb == $url_db_to_use && $url_organizer_enabled) || ($thisdb == $file_db_to_use && $file_organizer_enabled) )
	{
		//$handle = mysql_pconnect("localhost", "insertnamehere", "insertpasswordhere") or die(mysql_error());
		if ($dont_die)
		{	//echo "not dying";
			$handle = mysql_pconnect("localhost", "$mysql_username", "$mysql_password", $make_new_link);
			if (!$handle)
			{	return "mysql_pconnect error";
			}
			$result=mysql_select_db("$thisdb",$handle);
			if (!$result)
			{	return "mysql_select_db error";
			}
			return $handle;
		//	or die(mysql_error());
			//or die(mysql_error());
		}
		else
		{
			$handle = mysql_pconnect("localhost", "$mysql_username", "$mysql_password", $make_new_link) or die(mysql_error());
			
			mysql_select_db("$thisdb",$handle) or die(mysql_error());
			return $handle;
		}
	}
	else
	{	echo "<b>Astroblahhh Desktop ConnectToDb function error:</b> Unacceptable DB name - $thisdb";
		exit;
	}
}



function CreateDirs($arr_path, $thispathdisk)
{	//06:08 06/03/2011. Oops, could've just used mkdir with additional parameters...
	foreach ($arr_path as $thisdir)
	{	$thispath=$thispathdisk . $prevdirs . "/" . $thisdir;
		$thispath_parentdirs=$thispathdisk . $prevdirs;
		echo "Thispath: $thispath"; // Parentdirs $thispath_parentdirs ";
		if (!file_exists($thispath) )
		{	echo "Nonexistent path: $thispath<br>";
			if (is_writable( $thispath_parentdirs) )
			{	echo "Writable";
				if (!mkdir( $thispath ))
				{	echo "Couldn't make dir, returning false";
					return false;
				}
			}
			else
			{	return false;
			}
		}
		$prevdirs .= "/" . $thisdir;
	}
	return true;
}



function MakeNeededFols($paths)
{
	foreach ($paths as $path)
	{	global ${$path};
		if (!file_exists(${$path}) )
		{	mkdir( ${$path} );
		}
	}
}



function PrintDBHeader($dbtype, $noisy=true)
{	
	$dbvarname="$dbtype" . "_db_to_use";
	global ${$dbvarname};
	$dispdb=ucwords( ${$dbvarname} );
	$res="<big>DB: $dispdb</big>";
	if ($noisy)
	{	echo $res;
	}
	else
	{	return $res;
	}
	
}



function CheckOpera()
{
	$browser = $_SERVER['HTTP_USER_AGENT'];
	$opera=strpos($browser, "Opera");
	if ($opera!==false)
	//$browser=="Opera/9.21 (Windows NT 5.1; U; en)")
	{	return true;
	}
}



function GetFNExt($basename)
{	
	$dotloc=strrpos($basename, ".");
	
	if ($dotloc || $dotloc===0)
	{	$thisext=substr($basename, $dotloc+1);
		if ($dotloc!==0)
		{	$thisfn=substr($basename, 0, $dotloc);
		}
	}
	else
	{
		$thisfn=$basename;
	}
	$arr=array($thisfn, $thisext);
	return $arr;
}



function CheckOpera921()
{
	$browser = $_SERVER['HTTP_USER_AGENT'];
	if ($browser=="Opera/9.21 (Windows NT 5.1; U; en)")
	{	return true;
	}
}



function OperaCSS()
{
	echo "	.imp, .fav, .forsite, .onsite, .freq, .repo, .pile, .trv, .redun, .trav, .bundle, .deadb, .sav, .inao, .noao, .inaou, .bigdate, .arcd, .cpile
{	border-style: ridge;
}
.catsymb
{
	font-size: x-large;
}
.scores
{	font-size: large;
}
	";
}



function GoodIP()
{	global $neededip, $allow_only_one_ip;
	$ip=$_SERVER[REMOTE_ADDR];

	if ($allow_only_one_ip==false)
	{	return true;
	}
	
	if ($ip!=$neededip)
	{	return false;
	}
	else
	{
		return true;
	}
}



function CheckIP()
{
	if (GoodIP() )
	{
		return true;
	}
	else
	{	$logentry = "Wrong IP";
		GetLost($logentry);
		exit;
	}
}



function GetLost($logentry)
{	global $localpath_of__abdesktop, $keypath, $notkeypath, $tripwire;
	$logentry = "Get Lost - " . $logentry;
	AddLogEntry($logentry);
}



function AddLogEntry($logentrytype)
{	global $localpath_for_logfile, $fnforlog;

	$ip = $_SERVER['REMOTE_ADDR'];
	$hostaddress = gethostbyaddr($ip);
	$browser = $_SERVER['HTTP_USER_AGENT'];
	$referred = $_SERVER['HTTP_REFERER'];
	$requestmethod = $_SERVER['REQUEST_METHOD'];
	$timestamp=GetNowTimestamp();
	$timestamp .= " GMT";

	if ($referred == "")

	{	$referred="Direct request";
	}

	$filetext="<?php exit; ?><li>$timestamp - $requestmethod $logentrytype
$ip - $hostaddress | $browser
Accessed: $fnforlog
Ref: $referred\n\n";

	$openthis=$localpath_for_logfile;

	AppendToFile($localpath_for_logfile, $filetext);
}



function AppendToFile($openthis, $filetext)
{
	//$openthis needs to be set equal to a file path (appropriate for internal PHP use),
	//formatted like so: C:/xampp/htdocs/AC-Mirror/blog.shtml
	//echo $openthis;
	//$filetext is set equal to whatever text the file is supposed to contain.
	if ( !file_exists($openthis) )
	{	$arr_openthis=explode("/", $openthis);
		PrintArr($arr_openthis);
		$disk=array_shift($arr_openthis);
		array_pop($arr_openthis);
		//echo "disk $disk";
		//$disk=substr ($disk, 0, -1);
		//echo "disk $disk";
		CreateDirs($arr_openthis, $disk);
	}
	$filehandle=fopen($openthis, "a");
	fwrite ($filehandle, $filetext);
	fclose ($filehandle);
	return true;
}



function CheckCookie()
{	global $cookiename, $cookievalue, $webpath_of__abdesktop;

	CheckIP();

	if ($_COOKIE[$cookiename] != $cookievalue )
	{	$logentry="Good IP and Bad Cookie";
		GetLost($logentry);
		header("Location: $webpath_of__abdesktop/loginform.php");
		exit;
	}
}



function GetMicrotime()
{
	$microtime=explode (" ", microtime() );
	$microtime = $microtime[1] + $microtime[0]; //Adds secs and microsecs
	return $microtime;
}



function IdentifyFilepathType($path)
{
	//14:14 05/17/2011.  If it starts with a /, assume it's a linux path.  if it doesn't, and it has a colon before the first /, assume it's windows.  otherwise, it's misformatted.
	$firstchar=substr($path, 0, 1);
//	echo "Firstchar: $firstchar ";
	if ($firstchar=="/")
	{	return "Linux";
	}
	
	$slashpos=strpos($path, "/");
	
	$char_before_slash=substr($path, $slashpos-1, 1);
	
	if ($char_before_slash==":")
	{	return "Windows";
	}
	
	return "Path With Unspecified Disk";
}



function MicrotimeElapsedAndMemoryUsage()
{
	$elapsed_microtime=MicrotimeElapsedSinceStart();
	$mem=number_format( memory_get_usage() );

	/*$res="Seconds since script start: $elapsed_microtime<br>
	Memory used (in bytes): $mem";*/
	
	$res="<b>Seconds:</b> $elapsed_microtime <b>Bytes:</b> $mem";
	return $res;
}



function MicrotimeElapsedSinceStart()
{
	global $microtime_at_start_of_lib_abdesk;
	$current_microtime=GetMicrotime();
	$elapsed_microtime=($current_microtime - $microtime_at_start_of_lib_abdesk);
	return $elapsed_microtime;
}



function UrlOrganizerNavLinks()
{	global $abdesktop_path, $url_db_to_use;
	echo "<div class='navlinks'><a href='$abdesktop_path" . "urls/url_adder_form.php?db=$url_db_to_use'>Add URL</a> - " . "<a href='$abdesktop_path" . "urls/multi_url_adder_form.php?db=$url_db_to_use'>Add Many</a> - <a href='$abdesktop_path" . "urls/list-urls.php?db=$url_db_to_use&p=0&a=desc&g=y&n=10&o=urlinfo.url_id%20desc&inc=rep,triv,trav,maybe,arc'>Long List</a> - <a href='$abdesktop_path" . "urls/list-urls.php'>List URLs</a> - <a href='$abdesktop_path" . "00main.php'>Main</a></div>";
	echo MicrotimeElapsedAndMemoryUsage();
}



function IdeaOrganizerNavLinks($omitlastline=0)
{
	global $abdesktop_path, $idea_db_to_use;
	echo "<div class='navlinks'><a href='$abdesktop_path" . "ideas/idea_record_editor_form.php?db=$idea_db_to_use'>Add Idea</a> - <a href='$abdesktop_path" . "ideas/multi_idea_adder_form.php?db=$idea_db_to_use'>Add Many</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php?p=0&db=$idea_db_to_use&a=desc&plpre=y&g=y&n=10&o=ideainfo.idea_id%20desc&inc=rep,triv,todo,stat,list,recur,arc,ques'>Long List</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php'>List Ideas</a> - <a href='$abdesktop_path" . "00main.php'>Main</a></div>";
	if (!$omitlastline)
	{	echo MicrotimeElapsedAndMemoryUsage();
	}
}



function FormatDateFields($date_type)
{
	$month="$date_type" . "month";
	$year="$date_type" . "year";
	$day="$date_type" . "day";
	
	global ${$month}, ${$year}, ${$day};
	
		if (${$month} || ${$year} )
		{	if (${$month} )
			{	$res = ${$month};
				if (${$day})
				{	$res .= "/${$day}";
				}
				if (${$year})
				{	$res .= "/${$year}";
				}
			}
			else if (${$year} && !${$month})
			{	$res=${$year};
			}
		}
		
	return $res;
		
	/*	if ($maindatemonth || $maindateyear)
		{	if ($maindatemonth)
			{	$maindate = $maindatemonth;
				if ($maindateday)
				{	$maindate .= "/$maindateday";
				}
				if ($maindateyear)
				{	$maindate .= "/$maindateyear";
				}
			}
			else if ($maindateyear && !$maindatemonth)
			{	$maindate=$maindateyear;
			}
		}*/
}


		
function AllOrganizerNavLinks()
{		global 
			$url_organizer_enabled, $idea_organizer_enabled, $file_organizer_enabled,
			$abdesktop_path, 
			$url_db_to_use, $idea_db_to_use, $file_db_to_use;
		
	if ($url_organizer_enabled)
	{
		echo "<div class='navlinks'><a href='$abdesktop_path" . "urls/url_adder_form.php?db=$url_db_to_use'>Add URL</a> - <a href='$abdesktop_path" . "urls/multi_url_adder_form.php?db=$url_db_to_use'>Add Many URLs</a> - <a href='$abdesktop_path" . "urls/list-urls.php?db=$url_db_to_use&p=0&a=desc&g=y&n=10&o=urlinfo.url_id%20desc&inc=rep,triv,trav,maybe,arc'>Long URLs List</a> - <a href='$abdesktop_path" . "urls/list-urls.php'>List URLs</a><br>";
	}
	if ($idea_organizer_enabled)
	{
		echo "<a href='$abdesktop_path" . "ideas/idea_record_editor_form.php?db=$idea_db_to_use'>Add Idea</a> - <a href='$abdesktop_path" . "ideas/multi_idea_adder_form.php?db=$idea_db_to_use'>Add Many Ideas</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php?p=0&db=$idea_db_to_use&a=desc&plpre=y&g=y&n=10&o=ideainfo.idea_id%20desc&inc=rep,triv,todo,stat,list,recur,arc,ques'>Long Ideas List</a> - <a href='$abdesktop_path" . "ideas/list-ideas.php'>List Ideas</a><br>";
	}
	if ($file_organizer_enabled)
	{
		echo "<a href='$abdesktop_path" . "files/file_adder_form.php?db=$file_db_to_use'>File Adder</a> -  <a href='$abdesktop_path" . "files/list-files.php?p=0&mtnl=y&db=$file_db_to_use&a=desc&g=y&n=15&o=fileinfo.file_id%20desc&inc=rep,triv,stat,unk,maybe,timecap,data,scour,prm,mir'>Long Files List</a> - <a href='$abdesktop_path" . "files/list-files.php'>List Files</a> - ";
	}
	echo "<a href='$abdesktop_path" . "00main.php'>Main</a></div>";
	echo MicrotimeElapsedAndMemoryUsage();

/*	echo MicrotimeElapsed();
	//echo " - ";
	echo "<br>";
	echo MemoryUsage();*/
	//EndTimer();
}



if ($current_organizer=="url")
{
	require ("$localpath_of__abdesktop/settings/settings-url_organizer.php");
}
else if ($current_organizer=="idea")
{
	require ("$localpath_of__abdesktop/settings/settings-idea_organizer.php");
}
else if ($current_organizer=="file")
{
	require ("$localpath_of__abdesktop/settings/settings-file_organizer.php");
}



function CleanInput(&$inp) //To protect against SQL injection security breaches.
{
	if ( !is_numeric($inp) && !is_array($inp) )
	{	$inp = mysql_real_escape_string($inp);
	};
	if (is_array($inp) )
	{	array_walk($inp, 'CleanInput');
	}
}



function LocateStringIn($haystack, $needle)
{	$res=strpos($haystack, $needle);
	return $res;
}



function ExtractFromString($string, $start, $end=0)
{
	if (!$end)
	{	$res=substr($string, $start);
	}
	else
	{
		$res=substr($string, $start, $end);
	}
}



function CleanThenEncloseOrIsNull($varname, $value, $enclosure, $force_enclosure_or_not=false)
{
	CleanInput($value);
	echo "NEWCLEANVALUE: $value -";
	$res=EncloseOrIsNull($varname, $value, $enclosure, $force_enclosure_or_not);
	return $res;
}



function EncloseOrIsNull($varname, $value, $enclosure, $force_enclosure=false)
{	
	if (!empty($value) && $value!="NULL" && !is_numeric($value) )
	{	
		//$reverse_enclosure=strrev($enclosure);
		$value = "$varname = " . $enclosure . $value . $enclosure;
	}
	else if (is_numeric($value))
	{	//Then we leave the value as is.
		//Unless its first character is a zero, in which case we better enclose it.
		if ($force_enclosure==true)
		{
			$value = "$varname = " . $enclosure . $value . $enclosure;
		}
		else
		{
			$zeropos=strpos($value, "0");

			//$zeropos=strpos($value, "0");
			$e_position=strpos($value, "e");
			
			if ( ($zeropos!==false && $zeropos<1) || ($e_position!==false ) )
		//	if ($zeropos!==false && $zeropos===0)
			{	$value = "$varname = " . $enclosure . $value . $enclosure;
			}
			else
			{
				$value = "$varname = " . $value;
			}
			
	/*		$e_position=strpos($value, "e");
			
			if ($e_position!==false)
			{
				$value = "$varname = " . $enclosure . $value . $enclosure;
			}
			else
			{
				$value = "$varname = " . $value;
			}
			*/
		}
		
	}
	else $value="isnull($varname)";
	return $value;
}



function GetItemType($filepath)
{	
	if ( !file_exists($filepath) )
	{	
		return false;
	}
	if ( is_file($filepath) )
	{	return "File";
	}
	if ( is_dir($filepath) )
	{	return "Dir";
	}
}



function mysql_field_array( $query )
{
	$field = mysql_num_fields( $query );

	for ( $i = 0; $i < $field; $i++ )
	{
		$names[] = mysql_field_name( $query, $i );
	}
       
	return $names;
}



function PrintQueryResultGrid($queryresult, $varstoget="")
{
	mysql_data_seek($queryresult,0);
	
	if (!$varstoget)
	{	$varstoget=mysql_field_array($queryresult);
	}
	//PrintArr($varstoget);
	$y=0;
	$len=count($varstoget);
	
	echo "<table border><tr><th>#";
	while ($y<$len)
	{	echo "<th>$varstoget[$y]";
		$y++;
	}
	$num=0;
	while ( $unpublishedpost_info = mysql_fetch_array($queryresult) )
	{	$num++;
		$y=0;
		echo "\n<tr><td>$num";
		while ($y<$len)
		{
			$varname=$varstoget[$y];
			${$varname} = $unpublishedpost_info[$varname];
			
			echo "<td>${$varname}";
			
			$y++;
		}
	}
	echo "</table>";
	mysql_data_seek($queryresult,0);
}



function GetBundlestringText($bundlestring, $class="bundle")
{	
	$arr_bundles=explode(";",$bundlestring);
	array_walk($arr_bundles, RemoveWhitespaceEtcFromTagArr);
	array_walk($arr_bundles, SpaceToNbsp);
	foreach ($arr_bundles as $thisbundle)
	{	$res .= "<span class=\"$class\">$thisbundle</span> ";
	}
	return $res;
}



function StripExtraSlashes($str)
{	return preg_replace("/(\/)+/", '/', $str);
}



function StripBackslashPeriods($string)
{
   $string=preg_replace('/[\\\\]+[\.\.]+/', '', $string);
   $string=preg_replace('/[\/]+[\.\.]+/', '', $string);

	return $string;
}



function BackslashesDetectedIn($inp)
{	if (strpos($inp, "\\")!==false)
	{
		return true;
	}
	return false;
}



function SlashDetectedIn($inp)
{	if (strpos($inp, "/")!==false)
	{
		return true;
	}
	return false;
}



function EchoWarn($inp)
{	echo "<span class='warning'>$inp</span><p>";
}



function EchoNotif($inp)
{	global $notifvarname;
	if (!$notifvarname)
	{	$notifvarname="notif";
	}
	echo "<span class='notif'>$inp</span><p>";
	$_SESSION[$notifvarname]=null;
	for($x=0;$x<10;$x++)
	{	$notifdisplaynum="notifdisp" . $x;
		$_SESSION[$notifdisplaynum]=null;
	}
/*	$_SESSION[notifdisp]=null;
	$_SESSION[notifdisp2]=null;
	$_SESSION[notifdisp3]=null;
	$_SESSION[notifdisp4]=null;
	$_SESSION[notifdisp5]=null;
	$_SESSION[notifdisp6]=null;*/
}



function DisplayWithNotif($displaythis, $num=0)
{	//echo "<p>Displaythis: $displaythis  Num: $num ";
	if (!$num)
	{	$_SESSION[notifdisp]=$displaythis;
	}
	else
	{	$notifvar="notifdisp$num";
		$_SESSION[$notifvar]=$displaythis;
	}
}



function EchoError($inp)
{	global $errorvarname;
	if (!$errorvarname)
	{	$unsetvarname="error";
	}
	else
	{	$unsetvarname=$errorvarname;
	}
	
	echo "<span class='error'>$inp</span><p>";
	$_SESSION[$unsetvarname]=null;
	$_SESSION[errdisplay]=null;
	$_SESSION[errdisplay2]=null;
	$_SESSION[errdisplay3]=null;
	$_SESSION[errdisplay4]=null;
}



function DisplayWithError($displaythis, $num=0)
{	
	if (!$num)
	{	$_SESSION[errdisplay]=$displaythis;
	}
	else
	{	$errvar="errdisplay$num";
		$_SESSION[$errvar]=$displaythis;
	}
	
//	$_SESSION[errdisplay]=$displaythis;
}



function br()
{	echo "<br>\n";
}



function p()
{	echo "<p>\n";
}



function OverwriteFile($openthis, $filetext, $silent=false)
{
	//$openthis needs to be set equal to a file path (appropriate for internal PHP use),
	//formatted like so: C:/xampp/htdocs/AC-Mirror/blog.shtml
	
	//$filetext is set equal to whatever text the file is supposed to contain.
	
	if (!$silent)
	{	echo "Outputting this: $openthis<br>";
	}
	
	$filehandle=fopen($openthis, "w");
	fwrite ($filehandle, $filetext);
	fclose ($filehandle);
	
	return true;
}



function EncloseOrNull($value, $enclosure, $force_enclosure=false)
{	
	if (!empty($value) && $value!="NULL" && !is_numeric($value) )
	//	if (!empty($value) && $value!="NULL" && ( !is_numeric($value) || (is_numeric($value) && $force_enclosure==true) ) )
	{	
		//$reverse_enclosure=strrev($enclosure);
		$value = $enclosure . $value . $enclosure;
	}
	else if (is_numeric($value))
	{	//Then we leave the value as is.
		//Unless its first character is a zero, in which case we better enclose it.
		//Otherwise MySQL strips off the zero.
		if ($force_enclosure==true)
		{
			$value = $enclosure . $value . $enclosure;
		}
		else
		{
			$zeropos=strpos($value, "0");
			$e_position=strpos($value, "e");
			// && $zeropos===0
			if ( ($zeropos!==false && $zeropos<1) || $e_position!==false )
			{	$value = $enclosure . $value . $enclosure;
			}
			
			//$e_position=strpos($value, "e");
			
		/*	if ($e_position!==false)
			{
				$value = $enclosure . $value . $enclosure;
			}*/
		}
	}
	else $value="NULL";
	return $value;
}



function GetSessionVar($varname)
{	global $prevformname, $itemid, $dbtype;

	$dbvar="$dbtype" . "_db_to_use";

	global ${$dbvar};
	
	$sessionvarname=$prevformname . "_orig_" . ${$dbvar} . "_" . "$itemid" . "_" . $varname;
	$sessionvar=$_SESSION[$sessionvarname];
	$sessionvar=ltrim($sessionvar);  //10:18 06/12/2011.  This ltrim shouldn't be necessary, but, the quotes/longdescs, when they get printed in the textarea fields, have whitespace automatically trimmed off the beginning (not by me), so the session var has to also be trimmed so it will match the posted var (if the posted var is unchanged).
	CleanInput($sessionvar);
	
//	CleanInput($_SESSION[$sessionvarname]);
//	$sessionvar=$_SESSION[$sessionvarname];
	
	//echo "Dbvar: $dbvar  Dbtype: $dbtype  Sessiovarname: $sessionvarname<br>";
	return $sessionvar;
}



function MakeQueryParts($id, $varstoget)
{	global $prevformname, $itemid;

	$querypartstring="querypart_";
	$itemid=$id;
	
	foreach ($varstoget as $varname)
	{
		global ${$varname};		
		$sessionvar=GetSessionVar($varname);
		//echo "Varname: $varname '$sessionvar' *** <b>$varname</b> - ${$varname} <br>";
		if ($sessionvar!=${$varname} )
		{
			$queryvarname=$querypartstring . $varname;
			${$queryvarname}="$varname =";
			$enclosedval=EncloseOrNull(${$varname}, "'");
			${$queryvarname} .= "$enclosedval, ";
			$allqueryparts .= ${$queryvarname};
		}
	}
	return $allqueryparts;
}



function PrintArr($arr, $text="Printed Array:")
{
	echo "<p><br><big><b>$text</b></big><p>";
	print_r($arr);
}



function GetFieldValue($fieldname, $db_info)
{
	//$arr=explode(".", $propertyname);
	//array_shift($arr);
//	$tableless_propertyname=implode(".", $arr);
	
	$res=$db_info[$fieldname];
	return $res;
}



function mysql_fetch_table_assoc($resource)
{
    // function to get all data from a query, without over-writing the same field
    // by using the table name and the field name as the index
   
    // get data first
    $data=mysql_fetch_row($resource);
    if(!$data) return $data; // end of data
   
    // get field info
    $fields=array();
    $index=0;
    $num_fields=mysql_num_fields($resource);
    while($index<$num_fields)
    {
        $meta=mysql_fetch_field($resource, $index);
        if(!$meta)
        {
            // if no field info then just use index number by default
            $fields[$index]=$index;
        }
        else
        {
            $fields[$index]='';
            // deal with field aliases - ie no table name (SELECT T_1.a AS temp)
            if(!empty($meta->table)) $fields[$index]=$meta->table.'.';
            // deal with raw data - ie no field name (SELECT 1)
            if(!empty($meta->name))  $fields[$index].=$meta->name; else $fields[$index].=$index;
        }
        $index++;
    }
    $assoc_data=array_combine($fields, $data);
    return $assoc_data;
} 



function array_iunique($array)
{
    return array_intersect_key($array,array_unique(array_map(strtolower,$array)));
}



function ArrRemoveEmptyValues($array)
{
	foreach($array as $key => $value)
	{
		if($value == "" || $value == " " || is_null($value)) 
		{
			unset($array[$key]);
		}
	}
	$array = array_values($array);
	return $array;
}



function RemoveWhitespaceEtcFromTagArr(&$arr)
{
	$arr=trim($arr);
	$arr=StripRN($arr);
	$arr=StripExtraMiddleSpaces($arr);
}



function GetError()
{	global $errorvarname, $error;

	if ($_SESSION[$errorvarname])
	{	$error=$_SESSION[$errorvarname];
	}
}



function StripRN($string)
{
   return preg_replace('/(\r\n)+|(\n|\r)+/', ' ', $string);
}



function StripExtraMiddleSpaces($string)
{
   return preg_replace('/\s\s+/', ' ', $string);
}



function SpaceToNbsp(&$string)
{	$string=preg_replace('/\s/', '&nbsp;', $string);
}



function MakeSQLInsertVals($varstoget)
{	
	foreach ($varstoget as $varname)
	{
		global ${$varname};

		$enclosedvarname="enclosed" . $varname;

		global ${$enclosedvarname};

		$sqlvals .= "${$enclosedvarname}, ";
		$x++;
	}
	$sqlvals=TrimComma($sqlvals);
	return $sqlvals;
}



function EncloseOrNullAll($vars)
{
	foreach ($vars as $varname)
	{	
		global ${$varname};
		$enclosedvarname="enclosed" . $varname;
		global ${$enclosedvarname};

		${$enclosedvarname}=EncloseOrNull(${$varname}, "'");
	}
}



function GetNowTimestamp()
{	$res=time();
	$res = date("Y-m-d H:i:s", $res);
	return $res;
}



function GetTimestampWithErrorReturn($rawdate)
{
	$res = MakeIntoUnixTimeWithErrorReturn($rawdate);
	if ($res!="invalid timestamp")
	{
		$res = date("Y-m-d H:i:s", $res);
	}
	return $res;
}



function MakeIntoUnixTimeWithErrorReturn ($str)
{	
	if (!empty($str))
	{
		if (($timestamp = strtotime($str)) === false) 
		{
			return "invalid timestamp";
		}
		return $timestamp;
	}
}



function GetTimestamp($rawdate)
{	$res = MakeIntoUnixTime($rawdate);
	$res = date("Y-m-d H:i:s", $res);
	return $res;
}



function MakeIntoUnixTime ($str)
{	
	if (!empty($str))
	{
		if (($timestamp = strtotime($str)) === false) 
		{
			GoBackToFormWithError("invalid timestamp");
			exit;
		} 
	
	return $timestamp;
	}
}



function FixCheckboxValues()
{	global $checkboxes;

	$x=0;
	$len=count($checkboxes);
	while ($x<$len)
	{	$thisbox=$checkboxes[$x];
		if ($thisbox!="y")
		{	$checkboxes[$x]="n";
		}
		$x++;
	}
}



function TrimComma($value)
{	$value=substr ($value, 0, -2);
	return $value;
}



function PrintHiddenInput($varname)
{	global ${$varname};

	if (${$varname}==false && ${$varname}!="0")
	{	return false;
	}	
	echo "<input type='hidden' name='$varname' value=\"";
	echo ${$varname};
	echo "\">\n";
}



function FixNumberboxValues()
{	global $numberboxes;
	$x=0;
	$len=count($numberboxes);
	while ($x<$len)
	{	$thisbox=$numberboxes[$x];
		if (!is_numeric($thisbox) || $thisbox===false)
		{
			unset($numberboxes[$x]);
		}
		$x++;
	}
}



function RemoveFormSessionVars($vars, $id)
{	global $prevformname, $dbtype;
	$dbvarname="$dbtype" . "_db_to_use";
	global ${$dbvarname};
	foreach ($vars as $varname)
	{	
		$sessionvarname=$prevformname . "_orig_" . "${$dbvarname}" . "_" . "$id" . "_" . $varname;
		//echo "Sessionvarname: $sessionvarname $_SESSION[$sessionvarname]<br>";
		unset($_SESSION[$sessionvarname]);
		$x++;
	}	
}



function GetBrowserQueryPart($browserstart, $browserlimit)
{
	if ($browserlimit || $browserstart)
	{	if (!$browserstart || !is_numeric($browserstart) )
		{	$browserstart=0;
		}
		if (!$browserlimit || !is_numeric($browserlimit) )
		{	$browserlimit=999999999999999;
		}
		$browserquerypart="LIMIT $browserstart, $browserlimit";
		return $browserquerypart;
	}
}



function FindBadChars($str)
{	
	//$badchars=preg_match_all("/:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	//$badchars=preg_match_all("/\/|:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	//echo "Str: $str";

	$badchars=preg_match_all("/\/|:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	
	//I HATE REGULAR EXPRESSIONS!
	//Now, just because the damn thing won't notice backslashes no matter what I do,
	//we have to bother with this:
	if (BackslashesDetectedIn($str))
	{	array_push($matches[0], "\\");
	}
	
	$matchstr=implode(" ", $matches[0]);

	if ($badchars>0)
	{	DisplayWithError($matchstr);
		global $error, $fbtempopen;
		$fbtempopen=true;
		$error="badchars";
	}
}



function RemoveQuotes(&$item)
{	$item=str_replace("\"", "", $item);
}



function MakeCheckbox($symbol=false, $name=false, $varname, $css="", $use_symbols=true,$use_color_for_symbols=true,  $use_color_for_name=true, $checkboxes_at_left=false, $two_nbsps_after_name=false)
{	global ${$varname};

	
	if ($css && $use_color_for_symbols )
	{
		echo "<span class='$css'>";
	}
	
	if (!$checkboxes_at_left)
	{	if ($use_symbols)
		{	if ($symbol)
			{	echo "&#x$symbol;";
			}
		}
		if ($css && $use_color_for_symbols && !$use_color_for_name)
		{
			echo "</span>";
		}
		if ($css && !$use_color_for_symbols && $use_color_for_name)
		{	echo "<span class='$css'>";
		}
		echo "$name";

	}
	
	echo "<input type=checkbox name='$varname' value='y' ";
	if (${$varname}=='y')
	{	echo "checked";
	}
	echo ">";
	if ($checkboxes_at_left)
	{	echo " ";
		if ($use_symbols)
		{	if ($symbol)
			{	echo "&#x$symbol; ";
			}
		}
		if ($css && $use_color_for_symbols && !$use_color_for_name)
		{
			echo "</span>";
		}
		if ($css && !$use_color_for_symbols && $use_color_for_name)
		{	echo "<span class='$css'>";
		}
		echo "$name";
	}
	if ($two_nbsps_after_name)
	{//	echo " &nbsp;&nbsp;";
		echo " &nbsp;";
	}
	if ($css && ($use_color_for_symbols || $use_color_for_name ) )
	{	echo "</span>";
	}
}



function PrettyNumberbox($symbol, $name, $varname, $css="", $use_symbols=true,$use_color_for_symbols=true,  $use_color_for_name=true, $size=4, $max=4)
{	global ${$varname};
	if ($css && $use_color_for_symbols )
	{
		echo "<span class='$css'>";
	}
	if ($use_symbols)
	{	if ($symbol)
		{	echo "&#x$symbol; ";
		}
	}
	if ($css && $use_color_for_symbols && !$use_color_for_name)
	{
		echo "</span>";
	}
	if ($css && !$use_color_for_symbols && $use_color_for_name)
	{	echo "<span class='$css'>";
	}
	echo "$name ";
	
	if ($use_color_for_symbols || $use_color_for_name)
	{	echo "</span>";
	}
	echo "<input type=\"text\" name=\"$varname\" value=\"${$varname}\" size=$size maxlength=$max>";
	
}


/**
 * Copy a file, or recursively copy a folder and its contents
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.0.1
 * @link        http://aidanlister.com/repos/v/function.copyr.php
 * @param       string   $source    Source path
 * @param       string   $dest      Destination path
 * @return      bool     Returns TRUE on success, FALSE on failure
 */
function copyr($source, $dest)
{
    // Check for symlinks
    if (is_link($source)) {
        return symlink(readlink($source), $dest);
    }

    // Simple copy for a file
    if (is_file($source)) {
        return copy($source, $dest);
    }

    // Make destination directory
    if (!is_dir($dest)) {
        mkdir($dest);
    }

    // Loop through the folder
    $dir = dir($source);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }

        // Deep copy directories
        copyr("$source/$entry", "$dest/$entry");
    }

    // Clean up
    $dir->close();
    return true;
}


