<?php



$url_record_editor_form_fields=array("url", "title", "shortdesc", "longdesc", "maintagstring", "othertagstring", "projectstring", "bundlestring", "otherbundlestring", "authorstring", "languagestring", "pagetype", "topic", "usefulness", "fun", "beauty", "humorousness", "necessity", "liking", "interest", "quality", "eduval", "updatefrequency", "reasonforsaving", "repository", "trivial", "savedfile", "archiveorg", "notinarchiveorg", "aodeny", "curio", "dead", "fav", "maybe", "archive", "aside", "forsite", "clutterpile", "junkpile", "important", "aesthetic", "utilit", "forfun", "educational", "humorous", "news", "frequent", "travelog", "maindateyear", "maindatemonth", "maindateday", "maindatetime", "datestartyear", "datestartmonth", "datestartday", "datestarttime", "datendyear", "datendmonth", "datendday", "datendtime", "maindatenotes", "daterangenotes", "toforstring", "locstring", "originstring");



function PerformQueriesToCreateNullEntriesForNewUrlInOtherTables($addedurl_id)
{	global $handle;

	$query_to_issue="INSERT INTO urllongdesc (url_id, longdesc) VALUES ($addedurl_id, NULL)";
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	
	$query_to_issue="INSERT INTO urlsourcenotes (url_id, sourcenotes) VALUES ($addedurl_id, NULL)";
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	
	$query_to_issue="INSERT INTO urlothernotes (url_id, othernotes) VALUES ($addedurl_id, NULL)";
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	//echo "DONE";
}



function GetAddUrlQuery($cleanurl, $x)
{
	global $protocol, $hostname, $suffix, $path, $dirsonly, $fullfilename, $filenameonly, $filext, $params, $anchor, $username, $password, $port, $numofdots, $dynamicurlornot, $earliest_col_date;
	//echo "$earliest_col_date ARGH";
	if ($earliest_col_date && $earliest_col_date!="now()")
	{
		$earliest_col_date="'$earliest_col_date'";
	}
	/*else
	{	$earliest_col_date="now()";
	}*/
	$thisquery="INSERT INTO urlinfo (protocol, hostname, suffix, path, dirsonly, fullfilename, filenameonly, filext, allparams, anchor, username, password, port, numofdots, isdynamicurl, url, repository, forsite, earliest_col_date, whenadded) VALUES ($protocol[$x], $hostname[$x], $suffix[$x], $path[$x], $dirsonly[$x], $fullfilename[$x], $filenameonly[$x], $filext[$x], $params[$x], $anchor[$x], $username[$x], $password[$x], $port[$x], $numofdots[$x], $dynamicurlornot[$x], '$cleanurl', 'y', 'unspecified', $earliest_col_date, now())";
	
	return $thisquery;
}



function PerformQueriesToUpdateXferredUrl($id)
{	global $url_record_editor_form_fields, $handle;

	$fields=$url_record_editor_form_fields;
	
	//array_pop($fields);
	$thisquery="UPDATE urlinfo SET ";
//	PrintArr($fields);
	foreach ($url_record_editor_form_fields as $field)
	{	global ${$field};
		
		$value=EncloseOrNull(${$field}, "'");
		if ($value=="NULL")
		{	continue;
		}
		else
		{
			$thisquery .= "$field = $value, ";
			$issuethisquery=true;
		}
	}
	if ($issuethisquery)
	{
		$thisquery=substr($thisquery, 0, -2);
		$thisquery .= " WHERE url_id=$id LIMIT 1";
		echo "Thisquery: $thisquery";
	
		$query_result=mysql_query($thisquery,$handle) or die(mysql_error());
	}
	
	exit;
}



function GetUrlDetails($cleanurl, $set)
{	
	global $handle, $protocol, $hostname, $suffix, $path, $dirsonly, $fullfilename, $filenameonly, $filext,  $params, $anchor, $username, $password, $port, $numofdots, $dynamicurlornot;

	$urlparts=parse_url($cleanurl);

	$protocol[$set]=$urlparts[scheme];
	$hostname[$set]=$urlparts[host];
	$username[$set]=$urlparts[user];
	$password[$set]=$urlparts[pass];

	$path[$set]=$urlparts[path];
	$path[$set]=ltrim($path[$set],"/");
	$path[$set]=rtrim($path[$set],"/");

	$params[$set]=$urlparts[query];
	$anchor[$set]=$urlparts[fragment];
	$port[$set]=$urlparts[port];

	if ($params[$set])
	{
		$dynamicurlornot[$set]="y";
	}
	else
	{
		$dynamicurlornot[$set]="n";
	}

	$numofdots[$set]=substr_count($hostname[$set], '.');

	$explosion=explode(".",$hostname[$set]);

	if ($numofdots[$set]!=0)
	{	$suffix[$set]=array_pop($explosion);
	}

	$dotpos=strpos($path[$set], ".");

	if ($dotpos)
	{	$slashpos=strpos($path[$set], "/");

		if ($slashpos<$dotpos)
		{	
			$explosion=explode(".",$path[$set]);
			$filext[$set]=array_pop($explosion);

			$filenameonly[$set]=array_pop($explosion);
			$filenameonly[$set]=explode("/",$filenameonly[$set]);
			$filenameonly[$set]=array_pop($filenameonly[$set]);
			$explosion=explode("/",$path[$set]);
			$fullfilename[$set]=array_pop($explosion);
		}

	}

	$explosion=explode("/",$path[$set]);
	array_pop($explosion);
	$dirsonly[$set]=implode("/",$explosion);

	$varstoenclose=array("protocol", "hostname", "username", "username", "password", "path", "params", "anchor", "port", "suffix", "filext", "filenameonly", "fullfilename", "dirsonly", "dynamicurlornot");

	foreach ($varstoenclose as $varname)
	{	${$varname}[$set]=EncloseOrNull(${$varname}[$set], "'");
	}
}



function MakeRawUrlStandard($rawurl)
{	global $handle;
	$rawurl = trim($rawurl);
	$rawurl=ConvertSpacesTo20($rawurl);

	$cleanurl=$rawurl;
	CleanInput($cleanurl);
	$cleanurl=rtrim($cleanurl,"/");
	return $cleanurl;
}



function MakeRawUrlClean($rawurl)
{	global $handle;

	$rawurl = trim($rawurl);	//Removes whitespace at edges of string.

	if (BackslashesDetectedIn($rawurl))
	{
		GoBackToFormWithError("backslashes");
	}

	if (strlen($rawurl)<8)
	{
		GoBackToFormWithError("too short");
	}

	if (ColonEtcAbsentIn($rawurl))
	{	if ($rawurl!=null)
		{
			GoBackToFormWithError("no protocol");
		}
	}

	$rawurl=ConvertSpacesTo20($rawurl);

	$cleanurl=$rawurl;
	CleanInput($cleanurl);
	$cleanurl=rtrim($cleanurl,"/");
	return $cleanurl;
}



function UnsetUrlDetails($set)
{	
	$varstounset=array("protocol", "hostname", "suffix", "path", "dirsonly", "fullfilename", "filenameonly", "filext", "params", "anchor", "username", "password", "port", "numofdots", "dynamicurlornot");
	//"repository", "contentsimported", "privacylevel", "licensetype", "whenadded", "importdate")
	foreach ($varstounset as $var)
	{	global ${$var};
		${$var}[$set]="";
	}
}



function MakeRawDateClean($rawdate)
{
	$cleandate=$rawdate;
	CleanInput($cleandate);
	return $cleandate;
}



function ConvertSpacesTo20($inp)
{
	if (strpos($inp, " "))
	{	
		$inp = str_replace(" ", "%20", $inp); //12:48 PM, 3/17/2011.  ereg_replace removed
	}
	return $inp;
}



function Convert20ToSpaces($inp)
{	if (strpos($inp, "%20"))
	{	
		$inp = str_replace("%20", " ", $inp); //12:48 PM, 3/17/2011.  ereg_replace removed
	}
	return $inp;
}



function ColonEtcAbsentIn($inp)
{
	if (strpos($inp, "://"))
	{	return false;
	}
	else return true;
}


